/**
 */
package com.engisis.sysphs.language.modelica;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>MDirection</b></em>', and utility methods for working with them. <!--
 * end-user-doc -->
 * @see com.engisis.sysphs.language.modelica.ModelicaPackage#getMDirection()
 * @model
 * @generated
 */
public enum MDirection implements Enumerator
{
    /**
     * The '<em><b>None</b></em>' literal object.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @see #NONE_VALUE
     * @generated
     * @ordered
     */
    NONE(0, "none", "none"),
    
    /**
     * The '<em><b>Input</b></em>' literal object.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @see #INPUT_VALUE
     * @generated
     * @ordered
     */
    INPUT(1, "input", "input"),
    
    /**
     * The '<em><b>Output</b></em>' literal object.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @see #OUTPUT_VALUE
     * @generated
     * @ordered
     */
    OUTPUT(2, "output", "output");
    
    /**
     * The '<em><b>None</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>None</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #NONE
     * @model name="none"
     * @generated
     * @ordered
     */
    public static final int NONE_VALUE = 0;
    
    /**
     * The '<em><b>Input</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Input</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #INPUT
     * @model name="input"
     * @generated
     * @ordered
     */
    public static final int INPUT_VALUE = 1;
    
    /**
     * The '<em><b>Output</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Output</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #OUTPUT
     * @model name="output"
     * @generated
     * @ordered
     */
    public static final int OUTPUT_VALUE = 2;
    
    /**
     * An array of all the '<em><b>MDirection</b></em>' enumerators. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final MDirection[] VALUES_ARRAY = new MDirection[]
        {
            NONE,
            INPUT,
            OUTPUT,
        };
    
    /**
     * A public read-only list of all the '<em><b>MDirection</b></em>' enumerators.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final List<MDirection> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));
    
    /**
     * Returns the '<em><b>MDirection</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param literal the literal.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MDirection get(String literal)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            MDirection result = VALUES_ARRAY[i];
            if (result.toString().equals(literal))
            {
                return result;
            }
        }
        return null;
    }
    
    /**
     * Returns the '<em><b>MDirection</b></em>' literal with the specified name.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param name the name.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MDirection getByName(String name)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            MDirection result = VALUES_ARRAY[i];
            if (result.getName().equals(name))
            {
                return result;
            }
        }
        return null;
    }
    
    /**
     * Returns the '<em><b>MDirection</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the integer value.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MDirection get(int value)
    {
        switch (value)
        {
            case NONE_VALUE: return NONE;
            case INPUT_VALUE: return INPUT;
            case OUTPUT_VALUE: return OUTPUT;
        }
        return null;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final int value;
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String name;
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String literal;
    
    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    private MDirection(int value, String name, String literal)
    {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public int getValue()
    {
      return value;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getName()
    {
      return name;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getLiteral()
    {
      return literal;
    }
    
    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString()
    {
        return literal;
    }
    
} // MDirection
