/**
 */
package com.engisis.sysphs.language.modelica;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc --> A representation of the literals of the enumeration '
 * <em><b>MVariability</b></em>', and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.modelica.ModelicaPackage#getMVariability()
 * @model
 * @generated
 */
public enum MVariability implements Enumerator
{
    /**
     * The '<em><b>Continuous</b></em>' literal object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #CONTINUOUS_VALUE
     * @generated
     * @ordered
     */
    CONTINUOUS(0, "continuous", "continuous"), /**
     * The '<em><b>Discrete</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #DISCRETE_VALUE
     * @generated
     * @ordered
     */
    DISCRETE(1, "discrete", "discrete"), /**
     * The '<em><b>Parameter</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #PARAMETER_VALUE
     * @generated
     * @ordered
     */
    PARAMETER(2, "parameter", "parameter"), /**
     * The '<em><b>Constant</b></em>' literal object.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #CONSTANT_VALUE
     * @generated
     * @ordered
     */
    CONSTANT(3, "constant", "constant");
    
    /**
     * The '<em><b>Continuous</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Continuous</b></em>' literal object isn't
     * clear, there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #CONTINUOUS
     * @model name="continuous"
     * @generated
     * @ordered
     */
    public static final int CONTINUOUS_VALUE = 0;
    
    /**
     * The '<em><b>Discrete</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Discrete</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #DISCRETE
     * @model name="discrete"
     * @generated
     * @ordered
     */
    public static final int DISCRETE_VALUE = 1;
    
    /**
     * The '<em><b>Parameter</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Parameter</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #PARAMETER
     * @model name="parameter"
     * @generated
     * @ordered
     */
    public static final int PARAMETER_VALUE = 2;
    
    /**
     * The '<em><b>Constant</b></em>' literal value.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of '<em><b>Constant</b></em>' literal object isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @see #CONSTANT
     * @model name="constant"
     * @generated
     * @ordered
     */
    public static final int CONSTANT_VALUE = 3;
    
    /**
     * An array of all the '<em><b>MVariability</b></em>' enumerators. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final MVariability[] VALUES_ARRAY = new MVariability[]
        {
            CONTINUOUS,
            DISCRETE,
            PARAMETER,
            CONSTANT,
        };
    
    /**
     * A public read-only list of all the '<em><b>MVariability</b></em>' enumerators.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final List<MVariability> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));
    
    /**
     * Returns the '<em><b>MVariability</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param literal the literal.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MVariability get(String literal)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            MVariability result = VALUES_ARRAY[i];
            if (result.toString().equals(literal))
            {
                return result;
            }
        }
        return null;
    }
    
    /**
     * Returns the '<em><b>MVariability</b></em>' literal with the specified name.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param name the name.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MVariability getByName(String name)
    {
        for (int i = 0; i < VALUES_ARRAY.length; ++i)
        {
            MVariability result = VALUES_ARRAY[i];
            if (result.getName().equals(name))
            {
                return result;
            }
        }
        return null;
    }
    
    /**
     * Returns the '<em><b>MVariability</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @param value the integer value.
     * @return the matching enumerator or <code>null</code>.
     * @generated
     */
    public static MVariability get(int value)
    {
        switch (value)
        {
            case CONTINUOUS_VALUE: return CONTINUOUS;
            case DISCRETE_VALUE: return DISCRETE;
            case PARAMETER_VALUE: return PARAMETER;
            case CONSTANT_VALUE: return CONSTANT;
        }
        return null;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final int value;
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String name;
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    private final String literal;
    
    /**
     * Only this class can construct instances.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    private MVariability(int value, String name, String literal)
    {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public int getValue()
    {
      return value;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getName()
    {
      return name;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String getLiteral()
    {
      return literal;
    }
    
    /**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString()
    {
        return literal;
    }
    
} // MVariability
