/**
 */
package com.engisis.sysphs.language.modelica;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.modelica.ModelicaPackage
 * @generated
 */
public class ModelicaFactory extends EFactoryImpl
{
    /**
     * The singleton instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static final ModelicaFactory eINSTANCE = init();
    
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static ModelicaFactory init()
    {
        try
        {
            ModelicaFactory theModelicaFactory = (ModelicaFactory)EPackage.Registry.INSTANCE.getEFactory(ModelicaPackage.eNS_URI);
            if (theModelicaFactory != null)
            {
                return theModelicaFactory;
            }
        }
        catch (Exception exception)
        {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new ModelicaFactory();
    }
    
    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public ModelicaFactory()
    {
        super();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass)
    {
        switch (eClass.getClassifierID())
        {
            case ModelicaPackage.MCLASS: return createMClass();
            case ModelicaPackage.MCOMPONENT: return createMComponent();
            case ModelicaPackage.MCONNECTOR: return createMConnector();
            case ModelicaPackage.MMODEL: return createMModel();
            case ModelicaPackage.MEQUATION: return createMEquation();
            case ModelicaPackage.MEXTENSION: return createMExtension();
            case ModelicaPackage.MBLOCK: return createMBlock();
            case ModelicaPackage.MTYPE: return createMType();
            case ModelicaPackage.MPRIMITIVE_TYPE: return createMPrimitiveType();
            case ModelicaPackage.MSTRING_VALUE: return createMStringValue();
            case ModelicaPackage.MBOOLEAN_VALUE: return createMBooleanValue();
            case ModelicaPackage.MINTEGER_VALUE: return createMIntegerValue();
            case ModelicaPackage.MREAL_VALUE: return createMRealValue();
            case ModelicaPackage.MEXPRESSION_VALUE: return createMExpressionValue();
            case ModelicaPackage.MALGORITHM: return createMAlgorithm();
            case ModelicaPackage.MMODIFICATION: return createMModification();
            case ModelicaPackage.MCONNECT: return createMConnect();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue)
    {
        switch (eDataType.getClassifierID())
        {
            case ModelicaPackage.MACCESS_CONTROL:
                return createMAccessControlFromString(eDataType, initialValue);
            case ModelicaPackage.MDIRECTION:
                return createMDirectionFromString(eDataType, initialValue);
            case ModelicaPackage.MVARIABILITY:
                return createMVariabilityFromString(eDataType, initialValue);
            case ModelicaPackage.MDATA_FLOW:
                return createMDataFlowFromString(eDataType, initialValue);
            case ModelicaPackage.MHIERARCHY:
                return createMHierarchyFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue)
    {
        switch (eDataType.getClassifierID())
        {
            case ModelicaPackage.MACCESS_CONTROL:
                return convertMAccessControlToString(eDataType, instanceValue);
            case ModelicaPackage.MDIRECTION:
                return convertMDirectionToString(eDataType, instanceValue);
            case ModelicaPackage.MVARIABILITY:
                return convertMVariabilityToString(eDataType, instanceValue);
            case ModelicaPackage.MDATA_FLOW:
                return convertMDataFlowToString(eDataType, instanceValue);
            case ModelicaPackage.MHIERARCHY:
                return convertMHierarchyToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MClass createMClass()
    {
        MClass mClass = new MClass();
        return mClass;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MComponent createMComponent()
    {
        MComponent mComponent = new MComponent();
        return mComponent;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MConnector createMConnector()
    {
        MConnector mConnector = new MConnector();
        return mConnector;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MModel createMModel()
    {
        MModel mModel = new MModel();
        return mModel;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MEquation createMEquation()
    {
        MEquation mEquation = new MEquation();
        return mEquation;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MExtension createMExtension()
    {
        MExtension mExtension = new MExtension();
        return mExtension;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MBlock createMBlock()
    {
        MBlock mBlock = new MBlock();
        return mBlock;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MType createMType()
    {
        MType mType = new MType();
        return mType;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MPrimitiveType createMPrimitiveType()
    {
        MPrimitiveType mPrimitiveType = new MPrimitiveType();
        return mPrimitiveType;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MStringValue createMStringValue()
    {
        MStringValue mStringValue = new MStringValue();
        return mStringValue;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MBooleanValue createMBooleanValue()
    {
        MBooleanValue mBooleanValue = new MBooleanValue();
        return mBooleanValue;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MIntegerValue createMIntegerValue()
    {
        MIntegerValue mIntegerValue = new MIntegerValue();
        return mIntegerValue;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MRealValue createMRealValue()
    {
        MRealValue mRealValue = new MRealValue();
        return mRealValue;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MExpressionValue createMExpressionValue()
    {
        MExpressionValue mExpressionValue = new MExpressionValue();
        return mExpressionValue;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MAlgorithm createMAlgorithm()
    {
        MAlgorithm mAlgorithm = new MAlgorithm();
        return mAlgorithm;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MModification createMModification()
    {
        MModification mModification = new MModification();
        return mModification;
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public MConnect createMConnect() {
        MConnect mConnect = new MConnect();
        return mConnect;
    }

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MAccessControl createMAccessControlFromString(EDataType eDataType, String initialValue)
    {
        MAccessControl result = MAccessControl.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertMAccessControlToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MDirection createMDirectionFromString(EDataType eDataType, String initialValue)
    {
        MDirection result = MDirection.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertMDirectionToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MVariability createMVariabilityFromString(EDataType eDataType, String initialValue)
    {
        MVariability result = MVariability.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertMVariabilityToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public MDataFlow createMDataFlowFromString(EDataType eDataType, String initialValue)
    {
        MDataFlow result = MDataFlow.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertMDataFlowToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public MHierarchy createMHierarchyFromString(EDataType eDataType, String initialValue)
    {
        MHierarchy result = MHierarchy.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String convertMHierarchyToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public ModelicaPackage getModelicaPackage()
    {
        return (ModelicaPackage)getEPackage();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static ModelicaPackage getPackage()
    {
        return ModelicaPackage.eINSTANCE;
    }
    
} // ModelicaFactory
