/**
 */
package com.engisis.sysphs.language.modelica.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.engisis.sysphs.language.modelica.*;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * @see com.engisis.sysphs.language.modelica.ModelicaPackage
 * @generated
 */
public class ModelicaAdapterFactory extends AdapterFactoryImpl
{
    /**
     * The cached model package.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static ModelicaPackage modelPackage;
    
    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public ModelicaAdapterFactory()
    {
        if (modelPackage == null)
        {
            modelPackage = ModelicaPackage.eINSTANCE;
        }
    }
    
    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code> if
     * the object is either the model's package or is an instance object of the
     * model. <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object)
    {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }
    
    /**
     * The switch that delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ModelicaSwitch<Adapter> modelSwitch = new ModelicaSwitch<Adapter>()
        {
            @Override
            public Adapter caseMNamedElement(MNamedElement object)
            {
                return createMNamedElementAdapter();
            }
            @Override
            public Adapter caseMClass(MClass object)
            {
                return createMClassAdapter();
            }
            @Override
            public Adapter caseMComponent(MComponent object)
            {
                return createMComponentAdapter();
            }
            @Override
            public Adapter caseMConnector(MConnector object)
            {
                return createMConnectorAdapter();
            }
            @Override
            public Adapter caseMModel(MModel object)
            {
                return createMModelAdapter();
            }
            @Override
            public Adapter caseMEquation(MEquation object)
            {
                return createMEquationAdapter();
            }
            @Override
            public Adapter caseMExtension(MExtension object)
            {
                return createMExtensionAdapter();
            }
            @Override
            public Adapter caseMElement(MElement object)
            {
                return createMElementAdapter();
            }
            @Override
            public Adapter caseMBlock(MBlock object)
            {
                return createMBlockAdapter();
            }
            @Override
            public Adapter caseMType(MType object)
            {
                return createMTypeAdapter();
            }
            @Override
            public Adapter caseMPrimitiveType(MPrimitiveType object)
            {
                return createMPrimitiveTypeAdapter();
            }
            @Override
            public Adapter caseMDataValue(MDataValue object)
            {
                return createMDataValueAdapter();
            }
            @Override
            public Adapter caseMStringValue(MStringValue object)
            {
                return createMStringValueAdapter();
            }
            @Override
            public Adapter caseMBooleanValue(MBooleanValue object)
            {
                return createMBooleanValueAdapter();
            }
            @Override
            public Adapter caseMIntegerValue(MIntegerValue object)
            {
                return createMIntegerValueAdapter();
            }
            @Override
            public Adapter caseMRealValue(MRealValue object)
            {
                return createMRealValueAdapter();
            }
            @Override
            public Adapter caseMExpressionValue(MExpressionValue object)
            {
                return createMExpressionValueAdapter();
            }
            @Override
            public Adapter caseMAlgorithm(MAlgorithm object)
            {
                return createMAlgorithmAdapter();
            }
            @Override
            public Adapter caseMModification(MModification object)
            {
                return createMModificationAdapter();
            }
            @Override
            public Adapter caseMConnect(MConnect object)
            {
                return createMConnectAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object)
            {
                return createEObjectAdapter();
            }
        };
    
    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target)
    {
        return modelSwitch.doSwitch((EObject)target);
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MNamedElement <em>MNamed Element</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MNamedElement
     * @generated
     */
    public Adapter createMNamedElementAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MClass
     * <em>MClass</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MClass
     * @generated
     */
    public Adapter createMClassAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MComponent <em>MComponent</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MComponent
     * @generated
     */
    public Adapter createMComponentAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MConnector <em>MConnector</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MConnector
     * @generated
     */
    public Adapter createMConnectorAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MModel
     * <em>MModel</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MModel
     * @generated
     */
    public Adapter createMModelAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MEquation
     * <em>MEquation</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MEquation
     * @generated
     */
    public Adapter createMEquationAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MExtension <em>MExtension</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MExtension
     * @generated
     */
    public Adapter createMExtensionAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MElement
     * <em>MElement</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MElement
     * @generated
     */
    public Adapter createMElementAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MBlock
     * <em>MBlock</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MBlock
     * @generated
     */
    public Adapter createMBlockAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link com.engisis.sysphs.language.modelica.MType
     * <em>MType</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MType
     * @generated
     */
    public Adapter createMTypeAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MPrimitiveType <em>MPrimitive Type</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MPrimitiveType
     * @generated
     */
    public Adapter createMPrimitiveTypeAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MDataValue <em>MData Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MDataValue
     * @generated
     */
    public Adapter createMDataValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MStringValue <em>MString Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MStringValue
     * @generated
     */
    public Adapter createMStringValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MBooleanValue <em>MBoolean Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MBooleanValue
     * @generated
     */
    public Adapter createMBooleanValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MIntegerValue <em>MInteger Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MIntegerValue
     * @generated
     */
    public Adapter createMIntegerValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MRealValue <em>MReal Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MRealValue
     * @generated
     */
    public Adapter createMRealValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MExpressionValue <em>MExpression Value</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MExpressionValue
     * @generated
     */
    public Adapter createMExpressionValueAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MAlgorithm <em>MAlgorithm</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MAlgorithm
     * @generated
     */
    public Adapter createMAlgorithmAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MModification <em>MModification</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MModification
     * @generated
     */
    public Adapter createMModificationAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.modelica.MConnect <em>MConnect</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.modelica.MConnect
     * @generated
     */
	public Adapter createMConnectAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter()
    {
        return null;
    }
    
} // ModelicaAdapterFactory
