/**
 */
package com.engisis.sysphs.language.modelica.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.util.Switch;

import com.engisis.sysphs.language.modelica.*;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.modelica.ModelicaPackage
 * @generated
 */
public class ModelicaSwitch<T> extends Switch<T>
{
    /**
     * The cached model package
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static ModelicaPackage modelPackage;
    
    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public ModelicaSwitch()
    {
        if (modelPackage == null)
        {
            modelPackage = ModelicaPackage.eINSTANCE;
        }
    }
    
    /**
     * Checks whether this is a switch for the given package. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @parameter ePackage the package in question.
     * @return whether this is a switch for the given package.
     * @generated
     */
    @Override
    protected boolean isSwitchFor(EPackage ePackage)
    {
        return ePackage == modelPackage;
    }
    
    /**
     * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @return the first non-null result returned by a <code>caseXXX</code> call.
     * @generated
     */
    @Override
    protected T doSwitch(int classifierID, EObject theEObject)
    {
        switch (classifierID)
        {
            case ModelicaPackage.MNAMED_ELEMENT:
            {
                MNamedElement mNamedElement = (MNamedElement)theEObject;
                T result = caseMNamedElement(mNamedElement);
                if (result == null) result = caseMElement(mNamedElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MCLASS:
            {
                MClass mClass = (MClass)theEObject;
                T result = caseMClass(mClass);
                if (result == null) result = caseMNamedElement(mClass);
                if (result == null) result = caseMElement(mClass);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MCOMPONENT:
            {
                MComponent mComponent = (MComponent)theEObject;
                T result = caseMComponent(mComponent);
                if (result == null) result = caseMNamedElement(mComponent);
                if (result == null) result = caseMElement(mComponent);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MCONNECTOR:
            {
                MConnector mConnector = (MConnector)theEObject;
                T result = caseMConnector(mConnector);
                if (result == null) result = caseMClass(mConnector);
                if (result == null) result = caseMNamedElement(mConnector);
                if (result == null) result = caseMElement(mConnector);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MMODEL:
            {
                MModel mModel = (MModel)theEObject;
                T result = caseMModel(mModel);
                if (result == null) result = caseMClass(mModel);
                if (result == null) result = caseMNamedElement(mModel);
                if (result == null) result = caseMElement(mModel);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MEQUATION:
            {
                MEquation mEquation = (MEquation)theEObject;
                T result = caseMEquation(mEquation);
                if (result == null) result = caseMElement(mEquation);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MEXTENSION:
            {
                MExtension mExtension = (MExtension)theEObject;
                T result = caseMExtension(mExtension);
                if (result == null) result = caseMElement(mExtension);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MELEMENT:
            {
                MElement mElement = (MElement)theEObject;
                T result = caseMElement(mElement);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MBLOCK:
            {
                MBlock mBlock = (MBlock)theEObject;
                T result = caseMBlock(mBlock);
                if (result == null) result = caseMClass(mBlock);
                if (result == null) result = caseMNamedElement(mBlock);
                if (result == null) result = caseMElement(mBlock);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MTYPE:
            {
                MType mType = (MType)theEObject;
                T result = caseMType(mType);
                if (result == null) result = caseMClass(mType);
                if (result == null) result = caseMNamedElement(mType);
                if (result == null) result = caseMElement(mType);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MPRIMITIVE_TYPE:
            {
                MPrimitiveType mPrimitiveType = (MPrimitiveType)theEObject;
                T result = caseMPrimitiveType(mPrimitiveType);
                if (result == null) result = caseMType(mPrimitiveType);
                if (result == null) result = caseMClass(mPrimitiveType);
                if (result == null) result = caseMNamedElement(mPrimitiveType);
                if (result == null) result = caseMElement(mPrimitiveType);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MDATA_VALUE:
            {
                MDataValue mDataValue = (MDataValue)theEObject;
                T result = caseMDataValue(mDataValue);
                if (result == null) result = caseMElement(mDataValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MSTRING_VALUE:
            {
                MStringValue mStringValue = (MStringValue)theEObject;
                T result = caseMStringValue(mStringValue);
                if (result == null) result = caseMDataValue(mStringValue);
                if (result == null) result = caseMElement(mStringValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MBOOLEAN_VALUE:
            {
                MBooleanValue mBooleanValue = (MBooleanValue)theEObject;
                T result = caseMBooleanValue(mBooleanValue);
                if (result == null) result = caseMDataValue(mBooleanValue);
                if (result == null) result = caseMElement(mBooleanValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MINTEGER_VALUE:
            {
                MIntegerValue mIntegerValue = (MIntegerValue)theEObject;
                T result = caseMIntegerValue(mIntegerValue);
                if (result == null) result = caseMDataValue(mIntegerValue);
                if (result == null) result = caseMElement(mIntegerValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MREAL_VALUE:
            {
                MRealValue mRealValue = (MRealValue)theEObject;
                T result = caseMRealValue(mRealValue);
                if (result == null) result = caseMDataValue(mRealValue);
                if (result == null) result = caseMElement(mRealValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MEXPRESSION_VALUE:
            {
                MExpressionValue mExpressionValue = (MExpressionValue)theEObject;
                T result = caseMExpressionValue(mExpressionValue);
                if (result == null) result = caseMDataValue(mExpressionValue);
                if (result == null) result = caseMElement(mExpressionValue);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MALGORITHM:
            {
                MAlgorithm mAlgorithm = (MAlgorithm)theEObject;
                T result = caseMAlgorithm(mAlgorithm);
                if (result == null) result = caseMElement(mAlgorithm);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MMODIFICATION:
            {
                MModification mModification = (MModification)theEObject;
                T result = caseMModification(mModification);
                if (result == null) result = caseMElement(mModification);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            case ModelicaPackage.MCONNECT:
            {
                MConnect mConnect = (MConnect)theEObject;
                T result = caseMConnect(mConnect);
                if (result == null) result = caseMEquation(mConnect);
                if (result == null) result = caseMElement(mConnect);
                if (result == null) result = defaultCase(theEObject);
                return result;
            }
            default: return defaultCase(theEObject);
        }
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MNamed Element</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MNamed Element</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMNamedElement(MNamedElement object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MClass</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MClass</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMClass(MClass object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MComponent</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MComponent</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMComponent(MComponent object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MConnector</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MConnector</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMConnector(MConnector object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MModel</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MModel</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMModel(MModel object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MEquation</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MEquation</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMEquation(MEquation object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MExtension</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MExtension</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMExtension(MExtension object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MElement</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MElement</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMElement(MElement object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MBlock</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MBlock</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMBlock(MBlock object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MType</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MType</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMType(MType object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MPrimitive Type</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MPrimitive Type</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMPrimitiveType(MPrimitiveType object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MData Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MData Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMDataValue(MDataValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MString Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MString Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMStringValue(MStringValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MBoolean Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MBoolean Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMBooleanValue(MBooleanValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MInteger Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MInteger Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMIntegerValue(MIntegerValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MReal Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MReal Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMRealValue(MRealValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MExpression Value</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MExpression Value</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMExpressionValue(MExpressionValue object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MAlgorithm</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MAlgorithm</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMAlgorithm(MAlgorithm object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MModification</em>'.
     * <!-- begin-user-doc --> This implementation
     * returns null; returning a non-null result will terminate the switch. <!--
     * end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MModification</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
    public T caseMModification(MModification object)
    {
        return null;
    }
    
    /**
     * Returns the result of interpreting the object as an instance of '<em>MConnect</em>'.
     * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>MConnect</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
     * @generated
     */
	public T caseMConnect(MConnect object) {
        return null;
    }

				/**
     * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
     * <!-- begin-user-doc --> This implementation returns
     * null; returning a non-null result will terminate the switch, but this is
     * the last case anyway. <!-- end-user-doc -->
     * @param object the target of the switch.
     * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
     * @see #doSwitch(org.eclipse.emf.ecore.EObject)
     * @generated
     */
    @Override
    public T defaultCase(EObject object)
    {
        return null;
    }
    
} // ModelicaSwitch
