/**
 */
package com.engisis.sysphs.language.simscape;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.simscape.SimscapePackage
 * @generated
 */
public class SimscapeFactory extends EFactoryImpl
{
    /**
     * The singleton instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static final SimscapeFactory eINSTANCE = init();
    
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static SimscapeFactory init()
    {
        try
        {
            SimscapeFactory theSimscapeFactory = (SimscapeFactory)EPackage.Registry.INSTANCE.getEFactory(SimscapePackage.eNS_URI);
            if (theSimscapeFactory != null)
            {
                return theSimscapeFactory;
            }
        }
        catch (Exception exception)
        {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new SimscapeFactory();
    }
    
    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public SimscapeFactory()
    {
        super();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass)
    {
        switch (eClass.getClassifierID())
        {
            case SimscapePackage.SCOMPONENT: return createSComponent();
            case SimscapePackage.SNODE: return createSNode();
            case SimscapePackage.SVARIABLE: return createSVariable();
            case SimscapePackage.SEQUATION: return createSEquation();
            case SimscapePackage.SDOMAIN: return createSDomain();
            case SimscapePackage.SINPUT: return createSInput();
            case SimscapePackage.SOUTPUT: return createSOutput();
            case SimscapePackage.SPARAMETER: return createSParameter();
            case SimscapePackage.SCOMPONENT_REFERENCE: return createSComponentReference();
            case SimscapePackage.SMEMBER_ASSIGNMENT: return createSMemberAssignment();
            case SimscapePackage.SCONNECTION: return createSConnection();
            case SimscapePackage.SMEMBER_PATH: return createSMemberPath();
            case SimscapePackage.SPACKAGE: return createSPackage();
            case SimscapePackage.SBRANCH: return createSBranch();
            case SimscapePackage.SPHYSICAL_BLOCK: return createSPhysicalBlock();
            case SimscapePackage.SPHYSICAL_LINE: return createSPhysicalLine();
            case SimscapePackage.SPHYSICAL_CONNECTION_POINT: return createSPhysicalConnectionPoint();
            case SimscapePackage.SCONNECTION_PORT_BLOCK: return createSConnectionPortBlock();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue)
    {
        switch (eDataType.getClassifierID())
        {
            case SimscapePackage.SMEMBER_ACCESS:
                return createSMemberAccessFromString(eDataType, initialValue);
            case SimscapePackage.SPROPAGATION:
                return createSPropagationFromString(eDataType, initialValue);
            case SimscapePackage.SCONVERSION:
                return createSConversionFromString(eDataType, initialValue);
            case SimscapePackage.SLOCATION:
                return createSLocationFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue)
    {
        switch (eDataType.getClassifierID())
        {
            case SimscapePackage.SMEMBER_ACCESS:
                return convertSMemberAccessToString(eDataType, instanceValue);
            case SimscapePackage.SPROPAGATION:
                return convertSPropagationToString(eDataType, instanceValue);
            case SimscapePackage.SCONVERSION:
                return convertSConversionToString(eDataType, instanceValue);
            case SimscapePackage.SLOCATION:
                return convertSLocationToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SComponent createSComponent()
    {
        SComponent sComponent = new SComponent();
        return sComponent;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SNode createSNode()
    {
        SNode sNode = new SNode();
        return sNode;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SVariable createSVariable()
    {
        SVariable sVariable = new SVariable();
        return sVariable;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SEquation createSEquation()
    {
        SEquation sEquation = new SEquation();
        return sEquation;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SDomain createSDomain()
    {
        SDomain sDomain = new SDomain();
        return sDomain;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SInput createSInput()
    {
        SInput sInput = new SInput();
        return sInput;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SOutput createSOutput()
    {
        SOutput sOutput = new SOutput();
        return sOutput;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SParameter createSParameter()
    {
        SParameter sParameter = new SParameter();
        return sParameter;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SComponentReference createSComponentReference()
    {
        SComponentReference sComponentReference = new SComponentReference();
        return sComponentReference;
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SMemberAssignment createSMemberAssignment() {
        SMemberAssignment sMemberAssignment = new SMemberAssignment();
        return sMemberAssignment;
    }

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SConnection createSConnection()
    {
        SConnection sConnection = new SConnection();
        return sConnection;
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SMemberPath createSMemberPath() {
        SMemberPath sMemberPath = new SMemberPath();
        return sMemberPath;
    }

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SPackage createSPackage()
    {
        SPackage sPackage = new SPackage();
        return sPackage;
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SBranch createSBranch() {
        SBranch sBranch = new SBranch();
        return sBranch;
    }

				/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SPhysicalBlock createSPhysicalBlock()
    {
        SPhysicalBlock sPhysicalBlock = new SPhysicalBlock();
        return sPhysicalBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SPhysicalLine createSPhysicalLine()
    {
        SPhysicalLine sPhysicalLine = new SPhysicalLine();
        return sPhysicalLine;
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SPhysicalConnectionPoint createSPhysicalConnectionPoint() {
        SPhysicalConnectionPoint sPhysicalConnectionPoint = new SPhysicalConnectionPoint();
        return sPhysicalConnectionPoint;
    }

				/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SConnectionPortBlock createSConnectionPortBlock()
    {
        SConnectionPortBlock sConnectionPortBlock = new SConnectionPortBlock();
        return sConnectionPortBlock;
    }

                /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SMemberAccess createSMemberAccessFromString(EDataType eDataType, String initialValue)
    {
        SMemberAccess result = SMemberAccess.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertSMemberAccessToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SPropagation createSPropagationFromString(EDataType eDataType, String initialValue)
    {
        SPropagation result = SPropagation.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertSPropagationToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SConversion createSConversionFromString(EDataType eDataType, String initialValue)
    {
        SConversion result = SConversion.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public String convertSConversionToString(EDataType eDataType, Object instanceValue)
    {
        return instanceValue == null ? null : instanceValue.toString();
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SLocation createSLocationFromString(EDataType eDataType, String initialValue) {
        SLocation result = SLocation.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSLocationToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SimscapePackage getSimscapePackage()
    {
        return (SimscapePackage)getEPackage();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static SimscapePackage getPackage()
    {
        return SimscapePackage.eINSTANCE;
    }
    
} // SimscapeFactory
