/**
 */
package com.engisis.sysphs.language.simscape.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.engisis.sysphs.language.simscape.*;
import com.engisis.sysphs.language.simulink.SBlock;
import com.engisis.sysphs.language.simulink.SElement;
import com.engisis.sysphs.language.simulink.SLine;
import com.engisis.sysphs.language.simulink.SNamedElement;
import com.engisis.sysphs.language.simulink.SSystem;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * @see com.engisis.sysphs.language.simscape.SimscapePackage
 * @generated
 */
public class SimscapeAdapterFactory extends AdapterFactoryImpl
{
    /**
     * The cached model package.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static SimscapePackage modelPackage;
    
    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public SimscapeAdapterFactory()
    {
        if (modelPackage == null)
        {
            modelPackage = SimscapePackage.eINSTANCE;
        }
    }
    
    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code> if
     * the object is either the model's package or is an instance object of the
     * model. <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object)
    {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }
    
    /**
     * The switch that delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SimscapeSwitch<Adapter> modelSwitch = new SimscapeSwitch<Adapter>()
        {
            @Override
            public Adapter caseSComponent(SComponent object)
            {
                return createSComponentAdapter();
            }
            @Override
            public Adapter caseSNode(SNode object)
            {
                return createSNodeAdapter();
            }
            @Override
            public Adapter caseSVariable(SVariable object)
            {
                return createSVariableAdapter();
            }
            @Override
            public Adapter caseSEquation(SEquation object)
            {
                return createSEquationAdapter();
            }
            @Override
            public Adapter caseSDomain(SDomain object)
            {
                return createSDomainAdapter();
            }
            @Override
            public Adapter caseSMember(SMember object)
            {
                return createSMemberAdapter();
            }
            @Override
            public Adapter caseSInput(SInput object)
            {
                return createSInputAdapter();
            }
            @Override
            public Adapter caseSOutput(SOutput object)
            {
                return createSOutputAdapter();
            }
            @Override
            public Adapter caseSParameter(SParameter object)
            {
                return createSParameterAdapter();
            }
            @Override
            public Adapter caseSComponentReference(SComponentReference object)
            {
                return createSComponentReferenceAdapter();
            }
            @Override
            public Adapter caseSMemberAssignment(SMemberAssignment object)
            {
                return createSMemberAssignmentAdapter();
            }
            @Override
            public Adapter caseSConnection(SConnection object)
            {
                return createSConnectionAdapter();
            }
            @Override
            public Adapter caseSMemberPath(SMemberPath object)
            {
                return createSMemberPathAdapter();
            }
            @Override
            public Adapter caseSPackage(SPackage object)
            {
                return createSPackageAdapter();
            }
            @Override
            public Adapter caseSBranch(SBranch object)
            {
                return createSBranchAdapter();
            }
            @Override
            public Adapter caseSPhysicalBlock(SPhysicalBlock object)
            {
                return createSPhysicalBlockAdapter();
            }
            @Override
            public Adapter caseSPhysicalLine(SPhysicalLine object)
            {
                return createSPhysicalLineAdapter();
            }
            @Override
            public Adapter caseSPhysicalConnectionPoint(SPhysicalConnectionPoint object)
            {
                return createSPhysicalConnectionPointAdapter();
            }
            @Override
            public Adapter caseSConnectionPortBlock(SConnectionPortBlock object)
            {
                return createSConnectionPortBlockAdapter();
            }
            @Override
            public Adapter caseSElement(SElement object)
            {
                return createSElementAdapter();
            }
            @Override
            public Adapter caseSNamedElement(SNamedElement object)
            {
                return createSNamedElementAdapter();
            }
            @Override
            public Adapter caseSSystem(SSystem object)
            {
                return createSSystemAdapter();
            }
            @Override
            public Adapter caseSBlock(SBlock object)
            {
                return createSBlockAdapter();
            }
            @Override
            public Adapter caseSLine(SLine object)
            {
                return createSLineAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object)
            {
                return createEObjectAdapter();
            }
        };
            
            /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
             * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
             @Override
             public Adapter createAdapter(Notifier target)
             {
        return modelSwitch.doSwitch((EObject)target);
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link gov.nist.sid.sysml2simulation.simscapetarget.simscape.SElement
              * <em>SElement</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see gov.nist.sid.sysml2simulation.simscapetarget.simscape.SElement
              * @generated
              */
             public Adapter createSElementAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SNamedElement <em>SNamed Element</em>}'.
     * <!-- begin-user-doc --> This default
              * implementation returns null so that we can easily ignore cases; it's
              * useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SNamedElement
     * @generated
     */
             public Adapter createSNamedElementAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SComponent <em>SComponent</em>}'.
     * <!-- begin-user-doc --> This default
              * implementation returns null so that we can easily ignore cases; it's
              * useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SComponent
     * @generated
     */
             public Adapter createSComponentAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SNode
              * <em>SNode</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SNode
              * @generated
              */
             public Adapter createSNodeAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SVariable
              * <em>SVariable</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SVariable
              * @generated
              */
             public Adapter createSVariableAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SEquation
              * <em>SEquation</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SEquation
              * @generated
              */
             public Adapter createSEquationAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SDomain
              * <em>SDomain</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SDomain
              * @generated
              */
             public Adapter createSDomainAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SMember
              * <em>SMember</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SMember
              * @generated
              */
             public Adapter createSMemberAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SInput
              * <em>SInput</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SInput
              * @generated
              */
             public Adapter createSInputAdapter()
             {
        return null;
    }
             
             /**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SOutput
              * <em>SOutput</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SOutput
              * @generated
              */
             public Adapter createSOutputAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SParameter <em>SParameter</em>}'.
     * <!-- begin-user-doc --> This default
              * implementation returns null so that we can easily ignore cases; it's
              * useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SParameter
     * @generated
     */
             public Adapter createSParameterAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SComponentReference <em>SComponent Reference</em>}'.
     * <!-- begin-user-doc --> This default
              * implementation returns null so that we can easily ignore cases; it's
              * useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SComponentReference
     * @generated
     */
             public Adapter createSComponentReferenceAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SMemberAssignment <em>SMember Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SMemberAssignment
     * @generated
     */
	public Adapter createSMemberAssignmentAdapter() {
        return null;
    }

													/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SConnection <em>SConnection</em>}'.
     * <!-- begin-user-doc --> This default
              * implementation returns null so that we can easily ignore cases; it's
              * useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SConnection
     * @generated
     */
             public Adapter createSConnectionAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SMemberPath <em>SMember Path</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SMemberPath
     * @generated
     */
	public Adapter createSMemberPathAdapter() {
        return null;
    }

													/**
              * Creates a new adapter for an object of class '
              * {@link com.engisis.sysphs.language.simscape.SPackage
              * <em>SPackage</em>}'. <!-- begin-user-doc --> This default implementation
              * returns null so that we can easily ignore cases; it's useful to ignore a
              * case when inheritance will catch all the cases anyway. <!-- end-user-doc
              * -->
              * 
              * @return the new adapter.
              * @see com.engisis.sysphs.language.simscape.SPackage
              * @generated
              */
             public Adapter createSPackageAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SBranch <em>SBranch</em>}'.
     * <!-- begin-user-doc -->
              * This default implementation returns null so that we can easily ignore cases;
              * it's useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SBranch
     * @generated
     */
             public Adapter createSBranchAdapter() {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SPhysicalBlock <em>SPhysical Block</em>}'.
     * <!-- begin-user-doc -->
              * This default implementation returns null so that we can easily ignore cases;
              * it's useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SPhysicalBlock
     * @generated
     */
             public Adapter createSPhysicalBlockAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SPhysicalLine <em>SPhysical Line</em>}'.
     * <!-- begin-user-doc -->
              * This default implementation returns null so that we can easily ignore cases;
              * it's useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SPhysicalLine
     * @generated
     */
             public Adapter createSPhysicalLineAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SPhysicalConnectionPoint <em>SPhysical Connection Point</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SPhysicalConnectionPoint
     * @generated
     */
	public Adapter createSPhysicalConnectionPointAdapter() {
        return null;
    }

													/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simscape.SConnectionPortBlock <em>SConnection Port Block</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simscape.SConnectionPortBlock
     * @generated
     */
    public Adapter createSConnectionPortBlockAdapter()
    {
        return null;
    }

                                                    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSystem <em>SSystem</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSystem
     * @generated
     */
	public Adapter createSSystemAdapter() {
        return null;
    }

													/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SBlock <em>SBlock</em>}'.
     * <!-- begin-user-doc -->
              * This default implementation returns null so that we can easily ignore cases;
              * it's useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SBlock
     * @generated
     */
             public Adapter createSBlockAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SLine <em>SLine</em>}'.
     * <!-- begin-user-doc -->
              * This default implementation returns null so that we can easily ignore cases;
              * it's useful to ignore a case when inheritance will catch all the cases anyway.
              * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SLine
     * @generated
     */
             public Adapter createSLineAdapter()
             {
        return null;
    }
             
             /**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc --> This
              * default implementation returns null. <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
             public Adapter createEObjectAdapter()
             {
        return null;
    }
             
} // SimscapeAdapterFactory
