/**
 */
package com.engisis.sysphs.language.simulink;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc --> The <b>Factory</b> for the model. It provides a
 * create method for each non-abstract class of the model. <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.simulink.SimulinkPackage
 * @generated
 */
public class SimulinkFactory extends EFactoryImpl
{
    /**
     * The singleton instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static final SimulinkFactory eINSTANCE = init();
    
    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public static SimulinkFactory init()
    {
        try
        {
            SimulinkFactory theSimulinkFactory = (SimulinkFactory)EPackage.Registry.INSTANCE.getEFactory(SimulinkPackage.eNS_URI);
            if (theSimulinkFactory != null)
            {
                return theSimulinkFactory;
            }
        }
        catch (Exception exception)
        {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new SimulinkFactory();
    }
    
    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public SimulinkFactory()
    {
        super();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    @Override
    public EObject create(EClass eClass)
    {
        switch (eClass.getClassifierID())
        {
            case SimulinkPackage.SSYSTEM: return createSSystem();
            case SimulinkPackage.SLINE: return createSLine();
            case SimulinkPackage.SMODEL: return createSModel();
            case SimulinkPackage.SINPORT: return createSInport();
            case SimulinkPackage.SOUTPORT: return createSOutport();
            case SimulinkPackage.SSUBSYSTEM: return createSSubsystem();
            case SimulinkPackage.SCONNECTION_POINT: return createSConnectionPoint();
            case SimulinkPackage.SLIBRARY: return createSLibrary();
            case SimulinkPackage.SREFERENCE: return createSReference();
            case SimulinkPackage.SEXPRESSION_VALUE: return createSExpressionValue();
            case SimulinkPackage.SDOUBLE_VALUE: return createSDoubleValue();
            case SimulinkPackage.SINTERFACE: return createSInterface();
            case SimulinkPackage.SSYSTEM_PARAMETER: return createSSystemParameter();
            case SimulinkPackage.STRIGGER: return createSTrigger();
            case SimulinkPackage.SSYSTEM_PARAMETER_ASSIGNMENT: return createSSystemParameterAssignment();
            case SimulinkPackage.SFUNCTION1: return createSFunction1();
            case SimulinkPackage.SF_INPUT_VARIABLE: return createSFInputVariable();
            case SimulinkPackage.SF_OUTPUT_VARIABLE: return createSFOutputVariable();
            case SimulinkPackage.SF_DISCRETE_STATE_VARIABLE: return createSFDiscreteStateVariable();
            case SimulinkPackage.SF_VARIABLE_ASSIGNMENT: return createSFVariableAssignment();
            case SimulinkPackage.SF_DERIVATIVE_ASSIGNMENT: return createSFDerivativeAssignment();
            case SimulinkPackage.SF_OUTPUT_ASSIGNMENT: return createSFOutputAssignment();
            case SimulinkPackage.SF_CONTINUOUS_STATE_VARIABLE: return createSFContinuousStateVariable();
            case SimulinkPackage.SF_UPDATE_ASSIGNMENT: return createSFUpdateAssignment();
            case SimulinkPackage.SFUNCTION1_BLOCK: return createSFunction1Block();
            case SimulinkPackage.SF_PARAMETER: return createSFParameter();
            case SimulinkPackage.SFUNCTION2_BLOCK: return createSFunction2Block();
            case SimulinkPackage.SFUNCTION2: return createSFunction2();
            case SimulinkPackage.SFD_WORK_VARIABLE: return createSFDWorkVariable();
            case SimulinkPackage.SFD_WORK_ASSIGNMENT: return createSFDWorkAssignment();
            case SimulinkPackage.SF_PARAMETER_ASSIGNMENT: return createSFParameterAssignment();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }
    
    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SSystem createSSystem() {
        SSystem sSystem = new SSystem();
        return sSystem;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SLine createSLine() {
        SLine sLine = new SLine();
        return sLine;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SModel createSModel() {
        SModel sModel = new SModel();
        return sModel;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SInport createSInport() {
        SInport sInport = new SInport();
        return sInport;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SOutport createSOutport() {
        SOutport sOutport = new SOutport();
        return sOutport;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SSubsystem createSSubsystem() {
        SSubsystem sSubsystem = new SSubsystem();
        return sSubsystem;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SConnectionPoint createSConnectionPoint() {
        SConnectionPoint sConnectionPoint = new SConnectionPoint();
        return sConnectionPoint;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SLibrary createSLibrary() {
        SLibrary sLibrary = new SLibrary();
        return sLibrary;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SReference createSReference() {
        SReference sReference = new SReference();
        return sReference;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SExpressionValue createSExpressionValue() {
        SExpressionValue sExpressionValue = new SExpressionValue();
        return sExpressionValue;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SDoubleValue createSDoubleValue() {
        SDoubleValue sDoubleValue = new SDoubleValue();
        return sDoubleValue;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SInterface createSInterface() {
        SInterface sInterface = new SInterface();
        return sInterface;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SSystemParameter createSSystemParameter() {
        SSystemParameter sSystemParameter = new SSystemParameter();
        return sSystemParameter;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public STrigger createSTrigger() {
        STrigger sTrigger = new STrigger();
        return sTrigger;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SSystemParameterAssignment createSSystemParameterAssignment() {
        SSystemParameterAssignment sSystemParameterAssignment = new SSystemParameterAssignment();
        return sSystemParameterAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFunction1 createSFunction1() {
        SFunction1 sFunction1 = new SFunction1();
        return sFunction1;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFInputVariable createSFInputVariable() {
        SFInputVariable sfInputVariable = new SFInputVariable();
        return sfInputVariable;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFOutputVariable createSFOutputVariable() {
        SFOutputVariable sfOutputVariable = new SFOutputVariable();
        return sfOutputVariable;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFDiscreteStateVariable createSFDiscreteStateVariable() {
        SFDiscreteStateVariable sfDiscreteStateVariable = new SFDiscreteStateVariable();
        return sfDiscreteStateVariable;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFVariableAssignment createSFVariableAssignment() {
        SFVariableAssignment sfVariableAssignment = new SFVariableAssignment();
        return sfVariableAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFDerivativeAssignment createSFDerivativeAssignment() {
        SFDerivativeAssignment sfDerivativeAssignment = new SFDerivativeAssignment();
        return sfDerivativeAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFOutputAssignment createSFOutputAssignment() {
        SFOutputAssignment sfOutputAssignment = new SFOutputAssignment();
        return sfOutputAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFContinuousStateVariable createSFContinuousStateVariable() {
        SFContinuousStateVariable sfContinuousStateVariable = new SFContinuousStateVariable();
        return sfContinuousStateVariable;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFUpdateAssignment createSFUpdateAssignment() {
        SFUpdateAssignment sfUpdateAssignment = new SFUpdateAssignment();
        return sfUpdateAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFunction1Block createSFunction1Block() {
        SFunction1Block sFunction1Block = new SFunction1Block();
        return sFunction1Block;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFParameter createSFParameter() {
        SFParameter sfParameter = new SFParameter();
        return sfParameter;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFunction2Block createSFunction2Block() {
        SFunction2Block sFunction2Block = new SFunction2Block();
        return sFunction2Block;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFunction2 createSFunction2() {
        SFunction2 sFunction2 = new SFunction2();
        return sFunction2;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFDWorkVariable createSFDWorkVariable() {
        SFDWorkVariable sfdWorkVariable = new SFDWorkVariable();
        return sfdWorkVariable;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFDWorkAssignment createSFDWorkAssignment() {
        SFDWorkAssignment sfdWorkAssignment = new SFDWorkAssignment();
        return sfdWorkAssignment;
    }

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SFParameterAssignment createSFParameterAssignment() {
        SFParameterAssignment sfParameterAssignment = new SFParameterAssignment();
        return sfParameterAssignment;
    }

				/**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public SimulinkPackage getSimulinkPackage()
    {
        return (SimulinkPackage)getEPackage();
    }
    
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
    @Deprecated
    public static SimulinkPackage getPackage()
    {
        return SimulinkPackage.eINSTANCE;
    }
    
} // SimulinkFactory
