/**
 */
package com.engisis.sysphs.language.simulink.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.engisis.sysphs.language.simulink.*;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It provides
 * an adapter <code>createXXX</code> method for each class of the model. <!--
 * end-user-doc -->
 * @see com.engisis.sysphs.language.simulink.SimulinkPackage
 * @generated
 */
public class SimulinkAdapterFactory extends AdapterFactoryImpl
{
    /**
     * The cached model package.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected static SimulinkPackage modelPackage;
    
    /**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * @generated
     */
    public SimulinkAdapterFactory()
    {
        if (modelPackage == null)
        {
            modelPackage = SimulinkPackage.eINSTANCE;
        }
    }
    
    /**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc --> This implementation returns <code>true</code> if
     * the object is either the model's package or is an instance object of the
     * model. <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object object)
    {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }
    
    /**
     * The switch that delegates to the <code>createXXX</code> methods. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SimulinkSwitch<Adapter> modelSwitch = new SimulinkSwitch<Adapter>()
        {
            @Override
            public Adapter caseSElement(SElement object)
            {
                return createSElementAdapter();
            }
            @Override
            public Adapter caseSNamedElement(SNamedElement object)
            {
                return createSNamedElementAdapter();
            }
            @Override
            public Adapter caseSSystem(SSystem object)
            {
                return createSSystemAdapter();
            }
            @Override
            public Adapter caseSBlock(SBlock object)
            {
                return createSBlockAdapter();
            }
            @Override
            public Adapter caseSLine(SLine object)
            {
                return createSLineAdapter();
            }
            @Override
            public Adapter caseSModel(SModel object)
            {
                return createSModelAdapter();
            }
            @Override
            public Adapter caseSInport(SInport object)
            {
                return createSInportAdapter();
            }
            @Override
            public Adapter caseSOutport(SOutport object)
            {
                return createSOutportAdapter();
            }
            @Override
            public Adapter caseSSubsystem(SSubsystem object)
            {
                return createSSubsystemAdapter();
            }
            @Override
            public Adapter caseSConnectionPoint(SConnectionPoint object)
            {
                return createSConnectionPointAdapter();
            }
            @Override
            public Adapter caseSLibrary(SLibrary object)
            {
                return createSLibraryAdapter();
            }
            @Override
            public Adapter caseSReference(SReference object)
            {
                return createSReferenceAdapter();
            }
            @Override
            public Adapter caseSDataValue(SDataValue object)
            {
                return createSDataValueAdapter();
            }
            @Override
            public Adapter caseSExpressionValue(SExpressionValue object)
            {
                return createSExpressionValueAdapter();
            }
            @Override
            public Adapter caseSDoubleValue(SDoubleValue object)
            {
                return createSDoubleValueAdapter();
            }
            @Override
            public Adapter caseSInterface(SInterface object)
            {
                return createSInterfaceAdapter();
            }
            @Override
            public Adapter caseSSystemParameter(SSystemParameter object)
            {
                return createSSystemParameterAdapter();
            }
            @Override
            public Adapter caseSTrigger(STrigger object)
            {
                return createSTriggerAdapter();
            }
            @Override
            public Adapter caseSSystemParameterAssignment(SSystemParameterAssignment object)
            {
                return createSSystemParameterAssignmentAdapter();
            }
            @Override
            public Adapter caseSFunction1(SFunction1 object)
            {
                return createSFunction1Adapter();
            }
            @Override
            public Adapter caseSFVariable(SFVariable object)
            {
                return createSFVariableAdapter();
            }
            @Override
            public Adapter caseSFInputVariable(SFInputVariable object)
            {
                return createSFInputVariableAdapter();
            }
            @Override
            public Adapter caseSFOutputVariable(SFOutputVariable object)
            {
                return createSFOutputVariableAdapter();
            }
            @Override
            public Adapter caseSFDiscreteStateVariable(SFDiscreteStateVariable object)
            {
                return createSFDiscreteStateVariableAdapter();
            }
            @Override
            public Adapter caseSFVariableAssignment(SFVariableAssignment object)
            {
                return createSFVariableAssignmentAdapter();
            }
            @Override
            public Adapter caseSFDerivativeAssignment(SFDerivativeAssignment object)
            {
                return createSFDerivativeAssignmentAdapter();
            }
            @Override
            public Adapter caseSFOutputAssignment(SFOutputAssignment object)
            {
                return createSFOutputAssignmentAdapter();
            }
            @Override
            public Adapter caseSFContinuousStateVariable(SFContinuousStateVariable object)
            {
                return createSFContinuousStateVariableAdapter();
            }
            @Override
            public Adapter caseSFUpdateAssignment(SFUpdateAssignment object)
            {
                return createSFUpdateAssignmentAdapter();
            }
            @Override
            public Adapter caseSFunction1Block(SFunction1Block object)
            {
                return createSFunction1BlockAdapter();
            }
            @Override
            public Adapter caseSFParameter(SFParameter object)
            {
                return createSFParameterAdapter();
            }
            @Override
            public Adapter caseSFunction2Block(SFunction2Block object)
            {
                return createSFunction2BlockAdapter();
            }
            @Override
            public Adapter caseSFunction2(SFunction2 object)
            {
                return createSFunction2Adapter();
            }
            @Override
            public Adapter caseSFDWorkVariable(SFDWorkVariable object)
            {
                return createSFDWorkVariableAdapter();
            }
            @Override
            public Adapter caseSFDWorkAssignment(SFDWorkAssignment object)
            {
                return createSFDWorkAssignmentAdapter();
            }
            @Override
            public Adapter caseSFunction(SFunction object)
            {
                return createSFunctionAdapter();
            }
            @Override
            public Adapter caseSFunctionBlock(SFunctionBlock object)
            {
                return createSFunctionBlockAdapter();
            }
            @Override
            public Adapter caseSFParameterAssignment(SFParameterAssignment object)
            {
                return createSFParameterAssignmentAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object)
            {
                return createEObjectAdapter();
            }
        };
    
    /**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
    @Override
    public Adapter createAdapter(Notifier target)
    {
        return modelSwitch.doSwitch((EObject)target);
    }
    
    /**
     * Creates a new adapter for an object of class '
     * {@link gov.nist.sid.sysml2simulation.simulinkcoretarget.simulinkcore.SElement
     * <em>SElement</em>}'. <!-- begin-user-doc --> This default implementation
     * returns null so that we can easily ignore cases; it's useful to ignore a
     * case when inheritance will catch all the cases anyway. <!-- end-user-doc
     * -->
     * 
     * @return the new adapter.
     * @see gov.nist.sid.sysml2simulation.simulinkcoretarget.simulinkcore.SElement
     * @generated
     */
    public Adapter createSElementAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SNamedElement <em>SNamed Element</em>}'.
     * <!-- begin-user-doc --> This default
     * implementation returns null so that we can easily ignore cases; it's
     * useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SNamedElement
     * @generated
     */
    public Adapter createSNamedElementAdapter()
    {
        return null;
    }
    
    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSystem <em>SSystem</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSystem
     * @generated
     */
	public Adapter createSSystemAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SBlock <em>SBlock</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SBlock
     * @generated
     */
	public Adapter createSBlockAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SLine <em>SLine</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SLine
     * @generated
     */
	public Adapter createSLineAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SModel <em>SModel</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SModel
     * @generated
     */
	public Adapter createSModelAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SInport <em>SInport</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SInport
     * @generated
     */
	public Adapter createSInportAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SOutport <em>SOutport</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SOutport
     * @generated
     */
	public Adapter createSOutportAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSubsystem <em>SSubsystem</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSubsystem
     * @generated
     */
	public Adapter createSSubsystemAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SConnectionPoint <em>SConnection Point</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SConnectionPoint
     * @generated
     */
	public Adapter createSConnectionPointAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SLibrary <em>SLibrary</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SLibrary
     * @generated
     */
	public Adapter createSLibraryAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SReference <em>SReference</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SReference
     * @generated
     */
	public Adapter createSReferenceAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SDataValue <em>SData Value</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SDataValue
     * @generated
     */
	public Adapter createSDataValueAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SExpressionValue <em>SExpression Value</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SExpressionValue
     * @generated
     */
	public Adapter createSExpressionValueAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SDoubleValue <em>SDouble Value</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SDoubleValue
     * @generated
     */
	public Adapter createSDoubleValueAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SInterface <em>SInterface</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SInterface
     * @generated
     */
	public Adapter createSInterfaceAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSystemParameter <em>SSystem Parameter</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSystemParameter
     * @generated
     */
	public Adapter createSSystemParameterAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.STrigger <em>STrigger</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.STrigger
     * @generated
     */
	public Adapter createSTriggerAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSystemParameterAssignment <em>SSystem Parameter Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSystemParameterAssignment
     * @generated
     */
	public Adapter createSSystemParameterAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunction1 <em>SFunction1</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunction1
     * @generated
     */
	public Adapter createSFunction1Adapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFVariable <em>SF Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFVariable
     * @generated
     */
	public Adapter createSFVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFInputVariable <em>SF Input Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFInputVariable
     * @generated
     */
	public Adapter createSFInputVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFOutputVariable <em>SF Output Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFOutputVariable
     * @generated
     */
	public Adapter createSFOutputVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFDiscreteStateVariable <em>SF Discrete State Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFDiscreteStateVariable
     * @generated
     */
	public Adapter createSFDiscreteStateVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFVariableAssignment <em>SF Variable Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFVariableAssignment
     * @generated
     */
	public Adapter createSFVariableAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFDerivativeAssignment <em>SF Derivative Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFDerivativeAssignment
     * @generated
     */
	public Adapter createSFDerivativeAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFOutputAssignment <em>SF Output Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFOutputAssignment
     * @generated
     */
	public Adapter createSFOutputAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFContinuousStateVariable <em>SF Continuous State Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFContinuousStateVariable
     * @generated
     */
	public Adapter createSFContinuousStateVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFUpdateAssignment <em>SF Update Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFUpdateAssignment
     * @generated
     */
	public Adapter createSFUpdateAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunction1Block <em>SFunction1 Block</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunction1Block
     * @generated
     */
	public Adapter createSFunction1BlockAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFParameter <em>SF Parameter</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFParameter
     * @generated
     */
	public Adapter createSFParameterAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunction2Block <em>SFunction2 Block</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunction2Block
     * @generated
     */
	public Adapter createSFunction2BlockAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunction2 <em>SFunction2</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunction2
     * @generated
     */
	public Adapter createSFunction2Adapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFDWorkVariable <em>SFD Work Variable</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFDWorkVariable
     * @generated
     */
	public Adapter createSFDWorkVariableAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFDWorkAssignment <em>SFD Work Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFDWorkAssignment
     * @generated
     */
	public Adapter createSFDWorkAssignmentAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunction <em>SFunction</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunction
     * @generated
     */
	public Adapter createSFunctionAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFunctionBlock <em>SFunction Block</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFunctionBlock
     * @generated
     */
    public Adapter createSFunctionBlockAdapter()
    {
        return null;
    }

                /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SFParameterAssignment <em>SF Parameter Assignment</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SFParameterAssignment
     * @generated
     */
	public Adapter createSFParameterAssignmentAdapter() {
        return null;
    }

																/**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc --> This
     * default implementation returns null. <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
    public Adapter createEObjectAdapter()
    {
        return null;
    }
    
} // SimulinkAdapterFactory
