/**
 */
package com.engisis.sysphs.language.stateflow;

import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.BasicInternalEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SJunction</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.engisis.sysphs.language.stateflow.SJunction#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunction()
 * @model kind="class"
 * @generated
 */
public class SJunction extends SLinkNode implements SConnectNode {
    /**
     * The cached value of the '{@link #getIncoming() <em>Incoming</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getIncoming()
     * @generated
     * @ordered
     */
    protected EList<STransition> incoming;

    /**
     * The cached value of the '{@link #getOutgoing() <em>Outgoing</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getOutgoing()
     * @generated
     * @ordered
     */
    protected EList<STransition> outgoing;

    /**
     * The default value of the '{@link #getType() <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getType()
     * @generated
     * @ordered
     */
    protected static final SJunctionType TYPE_EDEFAULT = SJunctionType.CONNECTIVE;
    
    /**
     * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getType()
     * @generated
     * @ordered
     */
    protected SJunctionType type = TYPE_EDEFAULT;
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SJunction() {
        super();
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return StateflowPackage.Literals.SJUNCTION;
    }
    
    /**
     * Returns the value of the '<em><b>Incoming</b></em>' reference list.
     * The list contents are of type {@link com.engisis.sysphs.language.stateflow.STransition}.
     * It is bidirectional and its opposite is '{@link com.engisis.sysphs.language.stateflow.STransition#getDst <em>Dst</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Incoming</em>' reference list.
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode_Incoming()
     * @see com.engisis.sysphs.language.stateflow.STransition#getDst
     * @model opposite="dst"
     *        extendedMetaData="name='incoming'"
     * @generated
     */
    public EList<STransition> getIncoming()
    {
        if (incoming == null)
        {
            incoming = new BasicInternalEList<STransition>(STransition.class);
        }
        return incoming;
    }

    /**
     * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
     * The list contents are of type {@link com.engisis.sysphs.language.stateflow.STransition}.
     * It is bidirectional and its opposite is '{@link com.engisis.sysphs.language.stateflow.STransition#getSrc <em>Src</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Outgoing</em>' reference list.
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode_Outgoing()
     * @see com.engisis.sysphs.language.stateflow.STransition#getSrc
     * @model opposite="src"
     * @generated
     */
    public EList<STransition> getOutgoing()
    {
        if (outgoing == null)
        {
            outgoing = new BasicInternalEList<STransition>(STransition.class);
        }
        return outgoing;
    }

    /**
     * Returns the value of the '<em><b>Type</b></em>' attribute.
     * The literals are from the enumeration {@link com.engisis.sysphs.language.stateflow.SJunctionType}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Type</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Type</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SJunctionType
     * @see #setType(SJunctionType)
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunction_Type()
     * @model
     * @generated
     */
    public SJunctionType getType() {
        return type;
    }
    
    /**
     * Sets the value of the '{@link com.engisis.sysphs.language.stateflow.SJunction#getType <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Type</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SJunctionType
     * @see #getType()
     * @generated
     */
    public void setType(SJunctionType newType) {
        type = newType == null ? TYPE_EDEFAULT : newType;
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getIncoming()).basicAdd(otherEnd, msgs);
            case StateflowPackage.SJUNCTION__OUTGOING:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutgoing()).basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                return ((InternalEList<?>)getIncoming()).basicRemove(otherEnd, msgs);
            case StateflowPackage.SJUNCTION__OUTGOING:
                return ((InternalEList<?>)getOutgoing()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                return getIncoming();
            case StateflowPackage.SJUNCTION__OUTGOING:
                return getOutgoing();
            case StateflowPackage.SJUNCTION__TYPE:
                return getType();
        }
        return super.eGet(featureID, resolve, coreType);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                getIncoming().clear();
                getIncoming().addAll((Collection<? extends STransition>)newValue);
                return;
            case StateflowPackage.SJUNCTION__OUTGOING:
                getOutgoing().clear();
                getOutgoing().addAll((Collection<? extends STransition>)newValue);
                return;
            case StateflowPackage.SJUNCTION__TYPE:
                setType((SJunctionType)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                getIncoming().clear();
                return;
            case StateflowPackage.SJUNCTION__OUTGOING:
                getOutgoing().clear();
                return;
            case StateflowPackage.SJUNCTION__TYPE:
                setType(TYPE_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID)
        {
            case StateflowPackage.SJUNCTION__INCOMING:
                return incoming != null && !incoming.isEmpty();
            case StateflowPackage.SJUNCTION__OUTGOING:
                return outgoing != null && !outgoing.isEmpty();
            case StateflowPackage.SJUNCTION__TYPE:
                return type != TYPE_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
    {
        if (baseClass == SConnectNode.class)
        {
            switch (derivedFeatureID)
            {
                case StateflowPackage.SJUNCTION__INCOMING: return StateflowPackage.SCONNECT_NODE__INCOMING;
                case StateflowPackage.SJUNCTION__OUTGOING: return StateflowPackage.SCONNECT_NODE__OUTGOING;
                default: return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
    {
        if (baseClass == SConnectNode.class)
        {
            switch (baseFeatureID)
            {
                case StateflowPackage.SCONNECT_NODE__INCOMING: return StateflowPackage.SJUNCTION__INCOMING;
                case StateflowPackage.SCONNECT_NODE__OUTGOING: return StateflowPackage.SJUNCTION__OUTGOING;
                default: return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (type: ");
        result.append(type);
        result.append(')');
        return result.toString();
    }
    
} // SJunction
