/**
 */
package com.engisis.sysphs.language.stateflow;

import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.BasicInternalEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SState</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.engisis.sysphs.language.stateflow.SState#getLabel <em>Label</em>}</li>
 *   <li>{@link com.engisis.sysphs.language.stateflow.SState#getType <em>Type</em>}</li>
 *   <li>{@link com.engisis.sysphs.language.stateflow.SState#getDecomposition <em>Decomposition</em>}</li>
 * </ul>
 *
 * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState()
 * @model kind="class"
 * @generated
 */
public class SState extends STreeNode implements SConnectNode
{
    /**
     * The cached value of the '{@link #getIncoming() <em>Incoming</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getIncoming()
     * @generated
     * @ordered
     */
    protected EList<STransition> incoming;

    /**
     * The cached value of the '{@link #getOutgoing() <em>Outgoing</em>}' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getOutgoing()
     * @generated
     * @ordered
     */
    protected EList<STransition> outgoing;

    /**
     * The default value of the '{@link #getLabel() <em>Label</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getLabel()
     * @generated
     * @ordered
     */
    protected static final String LABEL_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getLabel() <em>Label</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getLabel()
     * @generated
     * @ordered
     */
    protected String label = LABEL_EDEFAULT;

    /**
     * The default value of the '{@link #getType() <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getType()
     * @generated
     * @ordered
     */
    protected static final SStateType TYPE_EDEFAULT = SStateType.OR;
    
    /**
     * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getType()
     * @generated
     * @ordered
     */
    protected SStateType type = TYPE_EDEFAULT;
    
    /**
     * The default value of the '{@link #getDecomposition() <em>Decomposition</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDecomposition()
     * @generated
     * @ordered
     */
    protected static final SDecomposition DECOMPOSITION_EDEFAULT = SDecomposition.CLUSTER;
    
    /**
     * The cached value of the '{@link #getDecomposition() <em>Decomposition</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDecomposition()
     * @generated
     * @ordered
     */
    protected SDecomposition decomposition = DECOMPOSITION_EDEFAULT;
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SState()
    {
        super();
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EClass eStaticClass()
    {
        return StateflowPackage.Literals.SSTATE;
    }
    
    /**
     * Returns the value of the '<em><b>Incoming</b></em>' reference list.
     * The list contents are of type {@link com.engisis.sysphs.language.stateflow.STransition}.
     * It is bidirectional and its opposite is '{@link com.engisis.sysphs.language.stateflow.STransition#getDst <em>Dst</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Incoming</em>' reference list.
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode_Incoming()
     * @see com.engisis.sysphs.language.stateflow.STransition#getDst
     * @model opposite="dst"
     *        extendedMetaData="name='incoming'"
     * @generated
     */
    public EList<STransition> getIncoming()
    {
        if (incoming == null)
        {
            incoming = new BasicInternalEList<STransition>(STransition.class);
        }
        return incoming;
    }

    /**
     * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
     * The list contents are of type {@link com.engisis.sysphs.language.stateflow.STransition}.
     * It is bidirectional and its opposite is '{@link com.engisis.sysphs.language.stateflow.STransition#getSrc <em>Src</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Outgoing</em>' reference list.
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode_Outgoing()
     * @see com.engisis.sysphs.language.stateflow.STransition#getSrc
     * @model opposite="src"
     * @generated
     */
    public EList<STransition> getOutgoing()
    {
        if (outgoing == null)
        {
            outgoing = new BasicInternalEList<STransition>(STransition.class);
        }
        return outgoing;
    }

    /**
     * Returns the value of the '<em><b>Label</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Label</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Label</em>' attribute.
     * @see #setLabel(String)
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState_Label()
     * @model required="true"
     * @generated
     */
    public String getLabel()
    {
        return label;
    }

    /**
     * Sets the value of the '{@link com.engisis.sysphs.language.stateflow.SState#getLabel <em>Label</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Label</em>' attribute.
     * @see #getLabel()
     * @generated
     */
    public void setLabel(String newLabel)
    {
        label = newLabel;
    }

    /**
     * Returns the value of the '<em><b>Type</b></em>' attribute.
     * The literals are from the enumeration {@link com.engisis.sysphs.language.stateflow.SStateType}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Type</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Type</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SStateType
     * @see #setType(SStateType)
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState_Type()
     * @model
     * @generated
     */
    public SStateType getType()
    {
        return type;
    }
    
    /**
     * Sets the value of the '{@link com.engisis.sysphs.language.stateflow.SState#getType <em>Type</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Type</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SStateType
     * @see #getType()
     * @generated
     */
    public void setType(SStateType newType)
    {
        type = newType == null ? TYPE_EDEFAULT : newType;
    }
    
    /**
     * Returns the value of the '<em><b>Decomposition</b></em>' attribute.
     * The literals are from the enumeration {@link com.engisis.sysphs.language.stateflow.SDecomposition}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Decomposition</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * @return the value of the '<em>Decomposition</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SDecomposition
     * @see #setDecomposition(SDecomposition)
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState_Decomposition()
     * @model
     * @generated
     */
    public SDecomposition getDecomposition()
    {
        return decomposition;
    }
    
    /**
     * Sets the value of the '{@link com.engisis.sysphs.language.stateflow.SState#getDecomposition <em>Decomposition</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @param value the new value of the '<em>Decomposition</em>' attribute.
     * @see com.engisis.sysphs.language.stateflow.SDecomposition
     * @see #getDecomposition()
     * @generated
     */
    public void setDecomposition(SDecomposition newDecomposition)
    {
        decomposition = newDecomposition == null ? DECOMPOSITION_EDEFAULT : newDecomposition;
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getIncoming()).basicAdd(otherEnd, msgs);
            case StateflowPackage.SSTATE__OUTGOING:
                return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutgoing()).basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                return ((InternalEList<?>)getIncoming()).basicRemove(otherEnd, msgs);
            case StateflowPackage.SSTATE__OUTGOING:
                return ((InternalEList<?>)getOutgoing()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                return getIncoming();
            case StateflowPackage.SSTATE__OUTGOING:
                return getOutgoing();
            case StateflowPackage.SSTATE__LABEL:
                return getLabel();
            case StateflowPackage.SSTATE__TYPE:
                return getType();
            case StateflowPackage.SSTATE__DECOMPOSITION:
                return getDecomposition();
        }
        return super.eGet(featureID, resolve, coreType);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                getIncoming().clear();
                getIncoming().addAll((Collection<? extends STransition>)newValue);
                return;
            case StateflowPackage.SSTATE__OUTGOING:
                getOutgoing().clear();
                getOutgoing().addAll((Collection<? extends STransition>)newValue);
                return;
            case StateflowPackage.SSTATE__LABEL:
                setLabel((String)newValue);
                return;
            case StateflowPackage.SSTATE__TYPE:
                setType((SStateType)newValue);
                return;
            case StateflowPackage.SSTATE__DECOMPOSITION:
                setDecomposition((SDecomposition)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void eUnset(int featureID)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                getIncoming().clear();
                return;
            case StateflowPackage.SSTATE__OUTGOING:
                getOutgoing().clear();
                return;
            case StateflowPackage.SSTATE__LABEL:
                setLabel(LABEL_EDEFAULT);
                return;
            case StateflowPackage.SSTATE__TYPE:
                setType(TYPE_EDEFAULT);
                return;
            case StateflowPackage.SSTATE__DECOMPOSITION:
                setDecomposition(DECOMPOSITION_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID)
    {
        switch (featureID)
        {
            case StateflowPackage.SSTATE__INCOMING:
                return incoming != null && !incoming.isEmpty();
            case StateflowPackage.SSTATE__OUTGOING:
                return outgoing != null && !outgoing.isEmpty();
            case StateflowPackage.SSTATE__LABEL:
                return LABEL_EDEFAULT == null ? label != null : !LABEL_EDEFAULT.equals(label);
            case StateflowPackage.SSTATE__TYPE:
                return type != TYPE_EDEFAULT;
            case StateflowPackage.SSTATE__DECOMPOSITION:
                return decomposition != DECOMPOSITION_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }
    
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
    {
        if (baseClass == SConnectNode.class)
        {
            switch (derivedFeatureID)
            {
                case StateflowPackage.SSTATE__INCOMING: return StateflowPackage.SCONNECT_NODE__INCOMING;
                case StateflowPackage.SSTATE__OUTGOING: return StateflowPackage.SCONNECT_NODE__OUTGOING;
                default: return -1;
            }
        }
        return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
    {
        if (baseClass == SConnectNode.class)
        {
            switch (baseFeatureID)
            {
                case StateflowPackage.SCONNECT_NODE__INCOMING: return StateflowPackage.SSTATE__INCOMING;
                case StateflowPackage.SCONNECT_NODE__OUTGOING: return StateflowPackage.SSTATE__OUTGOING;
                default: return -1;
            }
        }
        return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String toString()
    {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (label: ");
        result.append(label);
        result.append(", type: ");
        result.append(type);
        result.append(", decomposition: ");
        result.append(decomposition);
        result.append(')');
        return result.toString();
    }
    
} // SState
