/**
 */
package com.engisis.sysphs.language.stateflow;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.stateflow.StateflowPackage
 * @generated
 */
public class StateflowFactory extends EFactoryImpl {
	/**
     * The singleton instance of the factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final StateflowFactory eINSTANCE = init();

	/**
     * Creates the default factory implementation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static StateflowFactory init() {
        try
        {
            StateflowFactory theStateflowFactory = (StateflowFactory)EPackage.Registry.INSTANCE.getEFactory(StateflowPackage.eNS_URI);
            if (theStateflowFactory != null)
            {
                return theStateflowFactory;
            }
        }
        catch (Exception exception)
        {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new StateflowFactory();
    }

	/**
     * Creates an instance of the factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public StateflowFactory() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public EObject create(EClass eClass) {
        switch (eClass.getClassifierID())
        {
            case StateflowPackage.SSTATEFLOW: return createSStateflow();
            case StateflowPackage.SMACHINE: return createSMachine();
            case StateflowPackage.SCHART: return createSChart();
            case StateflowPackage.SSTATE: return createSState();
            case StateflowPackage.SJUNCTION: return createSJunction();
            case StateflowPackage.STRANSITION: return createSTransition();
            case StateflowPackage.SDATA: return createSData();
            case StateflowPackage.SEVENT: return createSEvent();
            case StateflowPackage.SINSTANCE: return createSInstance();
            case StateflowPackage.SCHART_BLOCK: return createSChartBlock();
            case StateflowPackage.SCHART_SYSTEM: return createSChartSystem();
            case StateflowPackage.STARGET: return createSTarget();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
        }
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
        switch (eDataType.getClassifierID())
        {
            case StateflowPackage.SSTATE_TYPE:
                return createSStateTypeFromString(eDataType, initialValue);
            case StateflowPackage.SDECOMPOSITION:
                return createSDecompositionFromString(eDataType, initialValue);
            case StateflowPackage.SJUNCTION_TYPE:
                return createSJunctionTypeFromString(eDataType, initialValue);
            case StateflowPackage.SEVENT_SCOPE:
                return createSEventScopeFromString(eDataType, initialValue);
            case StateflowPackage.SDATA_TYPE:
                return createSDataTypeFromString(eDataType, initialValue);
            case StateflowPackage.SDATA_SCOPE:
                return createSDataScopeFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
        switch (eDataType.getClassifierID())
        {
            case StateflowPackage.SSTATE_TYPE:
                return convertSStateTypeToString(eDataType, instanceValue);
            case StateflowPackage.SDECOMPOSITION:
                return convertSDecompositionToString(eDataType, instanceValue);
            case StateflowPackage.SJUNCTION_TYPE:
                return convertSJunctionTypeToString(eDataType, instanceValue);
            case StateflowPackage.SEVENT_SCOPE:
                return convertSEventScopeToString(eDataType, instanceValue);
            case StateflowPackage.SDATA_TYPE:
                return convertSDataTypeToString(eDataType, instanceValue);
            case StateflowPackage.SDATA_SCOPE:
                return convertSDataScopeToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
        }
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SStateflow createSStateflow() {
        SStateflow sStateflow = new SStateflow();
        return sStateflow;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SMachine createSMachine() {
        SMachine sMachine = new SMachine();
        return sMachine;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SChart createSChart() {
        SChart sChart = new SChart();
        return sChart;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SState createSState() {
        SState sState = new SState();
        return sState;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SJunction createSJunction() {
        SJunction sJunction = new SJunction();
        return sJunction;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public STransition createSTransition() {
        STransition sTransition = new STransition();
        return sTransition;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SData createSData() {
        SData sData = new SData();
        return sData;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SEvent createSEvent() {
        SEvent sEvent = new SEvent();
        return sEvent;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SInstance createSInstance() {
        SInstance sInstance = new SInstance();
        return sInstance;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SChartBlock createSChartBlock() {
        SChartBlock sChartBlock = new SChartBlock();
        return sChartBlock;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SChartSystem createSChartSystem() {
        SChartSystem sChartSystem = new SChartSystem();
        return sChartSystem;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public STarget createSTarget() {
        STarget sTarget = new STarget();
        return sTarget;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SStateType createSStateTypeFromString(EDataType eDataType, String initialValue) {
        SStateType result = SStateType.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSStateTypeToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SDecomposition createSDecompositionFromString(EDataType eDataType, String initialValue) {
        SDecomposition result = SDecomposition.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSDecompositionToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SJunctionType createSJunctionTypeFromString(EDataType eDataType, String initialValue) {
        SJunctionType result = SJunctionType.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSJunctionTypeToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SEventScope createSEventScopeFromString(EDataType eDataType, String initialValue) {
        SEventScope result = SEventScope.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSEventScopeToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SDataType createSDataTypeFromString(EDataType eDataType, String initialValue) {
        SDataType result = SDataType.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSDataTypeToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public SDataScope createSDataScopeFromString(EDataType eDataType, String initialValue) {
        SDataScope result = SDataScope.get(initialValue);
        if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
        return result;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String convertSDataScopeToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public StateflowPackage getStateflowPackage() {
        return (StateflowPackage)getEPackage();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @deprecated
     * @generated
     */
	@Deprecated
	public static StateflowPackage getPackage() {
        return StateflowPackage.eINSTANCE;
    }

} //StateflowFactory
