/**
 */
package com.engisis.sysphs.language.stateflow;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.engisis.sysphs.language.simulink.SimulinkPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.stateflow.StateflowFactory
 * @model kind="package"
 * @generated
 */
public class StateflowPackage extends EPackageImpl {
	/**
     * The package name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final String eNAME = "stateflow";

	/**
     * The package namespace URI.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final String eNS_URI = "http://www.engisis.com/sysphs/stateflow";

	/**
     * The package namespace name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final String eNS_PREFIX = "stateflow";

	/**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final StateflowPackage eINSTANCE = com.engisis.sysphs.language.stateflow.StateflowPackage.init();

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SStateflow <em>SStateflow</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SStateflow
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSStateflow()
     * @generated
     */
	public static final int SSTATEFLOW = 0;

	/**
     * The feature id for the '<em><b>Machine</b></em>' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATEFLOW__MACHINE = SimulinkPackage.SELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Instance</b></em>' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATEFLOW__INSTANCE = SimulinkPackage.SELEMENT_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>SStateflow</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATEFLOW_FEATURE_COUNT = SimulinkPackage.SELEMENT_FEATURE_COUNT + 2;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SIdentifiedElement <em>SIdentified Element</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SIdentifiedElement
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSIdentifiedElement()
     * @generated
     */
	public static final int SIDENTIFIED_ELEMENT = 10;

	/**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SIDENTIFIED_ELEMENT__NAME = SimulinkPackage.SNAMED_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SIDENTIFIED_ELEMENT__ID = SimulinkPackage.SNAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
     * The number of structural features of the '<em>SIdentified Element</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SIDENTIFIED_ELEMENT_FEATURE_COUNT = SimulinkPackage.SNAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SMachine <em>SMachine</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SMachine
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSMachine()
     * @generated
     */
	public static final int SMACHINE = 1;

	/**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE__NAME = SIDENTIFIED_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE__ID = SIDENTIFIED_ELEMENT__ID;

	/**
     * The feature id for the '<em><b>Target</b></em>' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE__TARGET = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

	/**
     * The feature id for the '<em><b>Chart</b></em>' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE__CHART = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

	/**
     * The feature id for the '<em><b>Owning Stateflow</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE__OWNING_STATEFLOW = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

	/**
     * The number of structural features of the '<em>SMachine</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SMACHINE_FEATURE_COUNT = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SChart <em>SChart</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SChart
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChart()
     * @generated
     */
	public static final int SCHART = 2;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.STreeNode <em>STree Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.STreeNode
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTreeNode()
     * @generated
     */
    public static final int STREE_NODE = 12;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE__NAME = SIDENTIFIED_ELEMENT__NAME;

    /**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SConnectNode <em>SConnect Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SConnectNode
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode()
     * @generated
     */
    public static final int SCONNECT_NODE = 9;

    /**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SState <em>SState</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SState
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState()
     * @generated
     */
	public static final int SSTATE = 3;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SJunction <em>SJunction</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SJunction
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunction()
     * @generated
     */
	public static final int SJUNCTION = 4;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SLinkNode <em>SLink Node</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SLinkNode
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSLinkNode()
     * @generated
     */
    public static final int SLINK_NODE = 11;

    /**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.STransition <em>STransition</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.STransition
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTransition()
     * @generated
     */
	public static final int STRANSITION = 5;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SData <em>SData</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SData
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSData()
     * @generated
     */
	public static final int SDATA = 6;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SEvent <em>SEvent</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SEvent
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSEvent()
     * @generated
     */
	public static final int SEVENT = 7;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SInstance <em>SInstance</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SInstance
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSInstance()
     * @generated
     */
	public static final int SINSTANCE = 8;

	/**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE__ID = SIDENTIFIED_ELEMENT__ID;

    /**
     * The feature id for the '<em><b>Tree Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE__TREE_NODE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Link Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE__LINK_NODE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE__OWNING_TREE_NODE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>STree Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STREE_NODE_FEATURE_COUNT = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART__NAME = STREE_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART__ID = STREE_NODE__ID;

    /**
     * The feature id for the '<em><b>Tree Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCHART__TREE_NODE = STREE_NODE__TREE_NODE;

    /**
     * The feature id for the '<em><b>Link Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCHART__LINK_NODE = STREE_NODE__LINK_NODE;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCHART__OWNING_TREE_NODE = STREE_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Owning Machine</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART__OWNING_MACHINE = STREE_NODE_FEATURE_COUNT + 0;

				/**
     * The number of structural features of the '<em>SChart</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_FEATURE_COUNT = STREE_NODE_FEATURE_COUNT + 1;

                /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__NAME = STREE_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATE__ID = STREE_NODE__ID;

    /**
     * The feature id for the '<em><b>Tree Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__TREE_NODE = STREE_NODE__TREE_NODE;

    /**
     * The feature id for the '<em><b>Link Node</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__LINK_NODE = STREE_NODE__LINK_NODE;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__OWNING_TREE_NODE = STREE_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Incoming</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__INCOMING = STREE_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Outgoing</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__OUTGOING = STREE_NODE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Label</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SSTATE__LABEL = STREE_NODE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATE__TYPE = STREE_NODE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Decomposition</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATE__DECOMPOSITION = STREE_NODE_FEATURE_COUNT + 4;

    /**
     * The number of structural features of the '<em>SState</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SSTATE_FEATURE_COUNT = STREE_NODE_FEATURE_COUNT + 5;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SLINK_NODE__NAME = SIDENTIFIED_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SLINK_NODE__ID = SIDENTIFIED_ELEMENT__ID;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SLINK_NODE__OWNING_TREE_NODE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>SLink Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SLINK_NODE_FEATURE_COUNT = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SJUNCTION__NAME = SLINK_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SJUNCTION__ID = SLINK_NODE__ID;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SJUNCTION__OWNING_TREE_NODE = SLINK_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Incoming</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SJUNCTION__INCOMING = SLINK_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Outgoing</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SJUNCTION__OUTGOING = SLINK_NODE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Type</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SJUNCTION__TYPE = SLINK_NODE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>SJunction</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SJUNCTION_FEATURE_COUNT = SLINK_NODE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STRANSITION__NAME = SLINK_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STRANSITION__ID = SLINK_NODE__ID;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STRANSITION__OWNING_TREE_NODE = SLINK_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Src</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STRANSITION__SRC = SLINK_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Dst</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STRANSITION__DST = SLINK_NODE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Label</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STRANSITION__LABEL = SLINK_NODE_FEATURE_COUNT + 2;

    /**
     * The number of structural features of the '<em>STransition</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STRANSITION_FEATURE_COUNT = SLINK_NODE_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__NAME = SLINK_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__ID = SLINK_NODE__ID;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SDATA__OWNING_TREE_NODE = SLINK_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Scope</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__SCOPE = SLINK_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Data Type</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__DATA_TYPE = SLINK_NODE_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Machine</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__MACHINE = SLINK_NODE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Value</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA__VALUE = SLINK_NODE_FEATURE_COUNT + 3;

				/**
     * The number of structural features of the '<em>SData</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SDATA_FEATURE_COUNT = SLINK_NODE_FEATURE_COUNT + 4;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SEVENT__NAME = SLINK_NODE__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SEVENT__ID = SLINK_NODE__ID;

    /**
     * The feature id for the '<em><b>Owning Tree Node</b></em>' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SEVENT__OWNING_TREE_NODE = SLINK_NODE__OWNING_TREE_NODE;

    /**
     * The feature id for the '<em><b>Scope</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SEVENT__SCOPE = SLINK_NODE_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Machine</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SEVENT__MACHINE = SLINK_NODE_FEATURE_COUNT + 1;

    /**
     * The number of structural features of the '<em>SEvent</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SEVENT_FEATURE_COUNT = SLINK_NODE_FEATURE_COUNT + 2;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SINSTANCE__NAME = SIDENTIFIED_ELEMENT__NAME;

    /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SINSTANCE__ID = SIDENTIFIED_ELEMENT__ID;

    /**
     * The feature id for the '<em><b>Machine</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SINSTANCE__MACHINE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

    /**
     * The feature id for the '<em><b>Chart</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SINSTANCE__CHART = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

    /**
     * The feature id for the '<em><b>Owning Stateflow</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SINSTANCE__OWNING_STATEFLOW = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 2;

				/**
     * The number of structural features of the '<em>SInstance</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SINSTANCE_FEATURE_COUNT = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 3;

    /**
     * The feature id for the '<em><b>Incoming</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCONNECT_NODE__INCOMING = 0;

    /**
     * The feature id for the '<em><b>Outgoing</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCONNECT_NODE__OUTGOING = 1;

    /**
     * The number of structural features of the '<em>SConnect Node</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int SCONNECT_NODE_FEATURE_COUNT = 2;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SChartBlock <em>SChart Block</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SChartBlock
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChartBlock()
     * @generated
     */
	public static final int SCHART_BLOCK = 13;

				/**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK__NAME = SimulinkPackage.SSUBSYSTEM__NAME;

				/**
     * The feature id for the '<em><b>SID</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK__SID = SimulinkPackage.SSUBSYSTEM__SID;

				/**
     * The feature id for the '<em><b>Owning System</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK__OWNING_SYSTEM = SimulinkPackage.SSUBSYSTEM__OWNING_SYSTEM;

				/**
     * The feature id for the '<em><b>System</b></em>' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK__SYSTEM = SimulinkPackage.SSUBSYSTEM__SYSTEM;

				/**
     * The feature id for the '<em><b>Chart</b></em>' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK__CHART = SimulinkPackage.SSUBSYSTEM_FEATURE_COUNT + 0;

				/**
     * The number of structural features of the '<em>SChart Block</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_BLOCK_FEATURE_COUNT = SimulinkPackage.SSUBSYSTEM_FEATURE_COUNT + 1;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SChartSystem <em>SChart System</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SChartSystem
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChartSystem()
     * @generated
     */
	public static final int SCHART_SYSTEM = 14;

				/**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__NAME = SimulinkPackage.SSYSTEM__NAME;

	/**
     * The feature id for the '<em><b>Owned Lines</b></em>' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__OWNED_LINES = SimulinkPackage.SSYSTEM__OWNED_LINES;

	/**
     * The feature id for the '<em><b>Owning Subsystem</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__OWNING_SUBSYSTEM = SimulinkPackage.SSYSTEM__OWNING_SUBSYSTEM;

	/**
     * The feature id for the '<em><b>Owning Model</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__OWNING_MODEL = SimulinkPackage.SSYSTEM__OWNING_MODEL;

				/**
     * The feature id for the '<em><b>Systemparameters</b></em>' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__SYSTEMPARAMETERS = SimulinkPackage.SSYSTEM__SYSTEMPARAMETERS;

				/**
     * The feature id for the '<em><b>Sid</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM__SID = SimulinkPackage.SSYSTEM__SID;

				/**
     * The feature id for the '<em><b>Owned Blocks</b></em>' containment reference list.
     * <!-- begin-user-doc -->
				 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
				public static final int SCHART_SYSTEM__OWNED_BLOCKS = SimulinkPackage.SSYSTEM__OWNED_BLOCKS;

				/**
     * The number of structural features of the '<em>SChart System</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int SCHART_SYSTEM_FEATURE_COUNT = SimulinkPackage.SSYSTEM_FEATURE_COUNT + 0;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.STarget <em>STarget</em>}' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.STarget
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTarget()
     * @generated
     */
	public static final int STARGET = 15;

				/**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    public static final int STARGET__NAME = SIDENTIFIED_ELEMENT__NAME;

                /**
     * The feature id for the '<em><b>Id</b></em>' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STARGET__ID = SIDENTIFIED_ELEMENT__ID;

				/**
     * The feature id for the '<em><b>Owning Machine</b></em>' container reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STARGET__OWNING_MACHINE = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 0;

				/**
     * The number of structural features of the '<em>STarget</em>' class.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
	public static final int STARGET_FEATURE_COUNT = SIDENTIFIED_ELEMENT_FEATURE_COUNT + 1;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SStateType <em>SState Type</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SStateType
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSStateType()
     * @generated
     */
	public static final int SSTATE_TYPE = 16;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SDecomposition <em>SDecomposition</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SDecomposition
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDecomposition()
     * @generated
     */
	public static final int SDECOMPOSITION = 17;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SJunctionType <em>SJunction Type</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SJunctionType
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunctionType()
     * @generated
     */
	public static final int SJUNCTION_TYPE = 18;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SEventScope <em>SEvent Scope</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SEventScope
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSEventScope()
     * @generated
     */
	public static final int SEVENT_SCOPE = 19;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SDataType <em>SData Type</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SDataType
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDataType()
     * @generated
     */
	public static final int SDATA_TYPE = 20;

	/**
     * The meta object id for the '{@link com.engisis.sysphs.language.stateflow.SDataScope <em>SData Scope</em>}' enum.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see com.engisis.sysphs.language.stateflow.SDataScope
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDataScope()
     * @generated
     */
	public static final int SDATA_SCOPE = 21;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sStateflowEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sMachineEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sChartEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sStateEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sJunctionEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sTransitionEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sDataEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sEventEClass = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sInstanceEClass = null;

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass sConnectNodeEClass = null;

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sIdentifiedElementEClass = null;

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass sLinkNodeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    private EClass sTreeNodeEClass = null;

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sChartBlockEClass = null;

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sChartSystemEClass = null;

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EClass sTargetEClass = null;

				/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sStateTypeEEnum = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sDecompositionEEnum = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sJunctionTypeEEnum = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sEventScopeEEnum = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sDataTypeEEnum = null;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private EEnum sDataScopeEEnum = null;

	/**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see com.engisis.sysphs.language.stateflow.StateflowPackage#eNS_URI
     * @see #init()
     * @generated
     */
	private StateflowPackage() {
        super(eNS_URI, StateflowFactory.eINSTANCE);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static boolean isInited = false;

	/**
     * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
     * 
     * <p>This method is used to initialize {@link StateflowPackage#eINSTANCE} when that field is accessed.
     * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
	public static StateflowPackage init() {
        if (isInited) return (StateflowPackage)EPackage.Registry.INSTANCE.getEPackage(StateflowPackage.eNS_URI);

        // Obtain or create and register package
        StateflowPackage theStateflowPackage = (StateflowPackage)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof StateflowPackage ? EPackage.Registry.INSTANCE.get(eNS_URI) : new StateflowPackage());

        isInited = true;

        // Obtain or create and register interdependencies
        SimulinkPackage theSimulinkPackage = (SimulinkPackage)(EPackage.Registry.INSTANCE.getEPackage(SimulinkPackage.eNS_URI) instanceof SimulinkPackage ? EPackage.Registry.INSTANCE.getEPackage(SimulinkPackage.eNS_URI) : SimulinkPackage.eINSTANCE);

        // Create package meta-data objects
        theStateflowPackage.createPackageContents();
        theSimulinkPackage.createPackageContents();

        // Initialize created meta-data
        theStateflowPackage.initializePackageContents();
        theSimulinkPackage.initializePackageContents();

        // Mark meta-data to indicate it can't be changed
        theStateflowPackage.freeze();

  
        // Update the registry and return the package
        EPackage.Registry.INSTANCE.put(StateflowPackage.eNS_URI, theStateflowPackage);
        return theStateflowPackage;
    }


	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SStateflow <em>SStateflow</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SStateflow</em>'.
     * @see com.engisis.sysphs.language.stateflow.SStateflow
     * @generated
     */
	public EClass getSStateflow() {
        return sStateflowEClass;
    }

	/**
     * Returns the meta object for the containment reference '{@link com.engisis.sysphs.language.stateflow.SStateflow#getMachine <em>Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SStateflow#getMachine()
     * @see #getSStateflow()
     * @generated
     */
	public EReference getSStateflow_Machine() {
        return (EReference)sStateflowEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for the containment reference list '{@link com.engisis.sysphs.language.stateflow.SStateflow#getInstance <em>Instance</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Instance</em>'.
     * @see com.engisis.sysphs.language.stateflow.SStateflow#getInstance()
     * @see #getSStateflow()
     * @generated
     */
	public EReference getSStateflow_Instance() {
        return (EReference)sStateflowEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SMachine <em>SMachine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SMachine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SMachine
     * @generated
     */
	public EClass getSMachine() {
        return sMachineEClass;
    }

	/**
     * Returns the meta object for the containment reference '{@link com.engisis.sysphs.language.stateflow.SMachine#getTarget <em>Target</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the containment reference '<em>Target</em>'.
     * @see com.engisis.sysphs.language.stateflow.SMachine#getTarget()
     * @see #getSMachine()
     * @generated
     */
	public EReference getSMachine_Target() {
        return (EReference)sMachineEClass.getEStructuralFeatures().get(0);
    }


	/**
     * Returns the meta object for the containment reference list '{@link com.engisis.sysphs.language.stateflow.SMachine#getChart <em>Chart</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Chart</em>'.
     * @see com.engisis.sysphs.language.stateflow.SMachine#getChart()
     * @see #getSMachine()
     * @generated
     */
	public EReference getSMachine_Chart() {
        return (EReference)sMachineEClass.getEStructuralFeatures().get(1);
    }


	/**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.SMachine#getOwningStateflow <em>Owning Stateflow</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Stateflow</em>'.
     * @see com.engisis.sysphs.language.stateflow.SMachine#getOwningStateflow()
     * @see #getSMachine()
     * @generated
     */
	public EReference getSMachine_OwningStateflow() {
        return (EReference)sMachineEClass.getEStructuralFeatures().get(2);
    }


	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SChart <em>SChart</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SChart</em>'.
     * @see com.engisis.sysphs.language.stateflow.SChart
     * @generated
     */
	public EClass getSChart() {
        return sChartEClass;
    }

	/**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.SChart#getOwningMachine <em>Owning Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SChart#getOwningMachine()
     * @see #getSChart()
     * @generated
     */
	public EReference getSChart_OwningMachine() {
        return (EReference)sChartEClass.getEStructuralFeatures().get(0);
    }


	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SState <em>SState</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SState</em>'.
     * @see com.engisis.sysphs.language.stateflow.SState
     * @generated
     */
	public EClass getSState() {
        return sStateEClass;
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SState#getLabel <em>Label</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Label</em>'.
     * @see com.engisis.sysphs.language.stateflow.SState#getLabel()
     * @see #getSState()
     * @generated
     */
    public EAttribute getSState_Label()
    {
        return (EAttribute)sStateEClass.getEStructuralFeatures().get(0);
    }


    /**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SState#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SState#getType()
     * @see #getSState()
     * @generated
     */
	public EAttribute getSState_Type() {
        return (EAttribute)sStateEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SState#getDecomposition <em>Decomposition</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Decomposition</em>'.
     * @see com.engisis.sysphs.language.stateflow.SState#getDecomposition()
     * @see #getSState()
     * @generated
     */
	public EAttribute getSState_Decomposition() {
        return (EAttribute)sStateEClass.getEStructuralFeatures().get(2);
    }

	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SJunction <em>SJunction</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SJunction</em>'.
     * @see com.engisis.sysphs.language.stateflow.SJunction
     * @generated
     */
	public EClass getSJunction() {
        return sJunctionEClass;
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SJunction#getType <em>Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SJunction#getType()
     * @see #getSJunction()
     * @generated
     */
	public EAttribute getSJunction_Type() {
        return (EAttribute)sJunctionEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.STransition <em>STransition</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>STransition</em>'.
     * @see com.engisis.sysphs.language.stateflow.STransition
     * @generated
     */
	public EClass getSTransition() {
        return sTransitionEClass;
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.STransition#getSrc <em>Src</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Src</em>'.
     * @see com.engisis.sysphs.language.stateflow.STransition#getSrc()
     * @see #getSTransition()
     * @generated
     */
	public EReference getSTransition_Src() {
        return (EReference)sTransitionEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.STransition#getDst <em>Dst</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Dst</em>'.
     * @see com.engisis.sysphs.language.stateflow.STransition#getDst()
     * @see #getSTransition()
     * @generated
     */
	public EReference getSTransition_Dst() {
        return (EReference)sTransitionEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.STransition#getLabel <em>Label</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Label</em>'.
     * @see com.engisis.sysphs.language.stateflow.STransition#getLabel()
     * @see #getSTransition()
     * @generated
     */
    public EAttribute getSTransition_Label()
    {
        return (EAttribute)sTransitionEClass.getEStructuralFeatures().get(2);
    }


    /**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SData <em>SData</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SData</em>'.
     * @see com.engisis.sysphs.language.stateflow.SData
     * @generated
     */
	public EClass getSData() {
        return sDataEClass;
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SData#getScope <em>Scope</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Scope</em>'.
     * @see com.engisis.sysphs.language.stateflow.SData#getScope()
     * @see #getSData()
     * @generated
     */
	public EAttribute getSData_Scope() {
        return (EAttribute)sDataEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SData#getDataType <em>Data Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Data Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SData#getDataType()
     * @see #getSData()
     * @generated
     */
	public EAttribute getSData_DataType() {
        return (EAttribute)sDataEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SData#getMachine <em>Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SData#getMachine()
     * @see #getSData()
     * @generated
     */
	public EReference getSData_Machine() {
        return (EReference)sDataEClass.getEStructuralFeatures().get(2);
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SData#getValue <em>Value</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Value</em>'.
     * @see com.engisis.sysphs.language.stateflow.SData#getValue()
     * @see #getSData()
     * @generated
     */
	public EReference getSData_Value() {
        return (EReference)sDataEClass.getEStructuralFeatures().get(3);
    }


	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SEvent <em>SEvent</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SEvent</em>'.
     * @see com.engisis.sysphs.language.stateflow.SEvent
     * @generated
     */
	public EClass getSEvent() {
        return sEventEClass;
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SEvent#getScope <em>Scope</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Scope</em>'.
     * @see com.engisis.sysphs.language.stateflow.SEvent#getScope()
     * @see #getSEvent()
     * @generated
     */
	public EAttribute getSEvent_Scope() {
        return (EAttribute)sEventEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SEvent#getMachine <em>Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SEvent#getMachine()
     * @see #getSEvent()
     * @generated
     */
	public EReference getSEvent_Machine() {
        return (EReference)sEventEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SInstance <em>SInstance</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SInstance</em>'.
     * @see com.engisis.sysphs.language.stateflow.SInstance
     * @generated
     */
	public EClass getSInstance() {
        return sInstanceEClass;
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SInstance#getMachine <em>Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.SInstance#getMachine()
     * @see #getSInstance()
     * @generated
     */
	public EReference getSInstance_Machine() {
        return (EReference)sInstanceEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SInstance#getChart <em>Chart</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Chart</em>'.
     * @see com.engisis.sysphs.language.stateflow.SInstance#getChart()
     * @see #getSInstance()
     * @generated
     */
	public EReference getSInstance_Chart() {
        return (EReference)sInstanceEClass.getEStructuralFeatures().get(1);
    }

	/**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.SInstance#getOwningStateflow <em>Owning Stateflow</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Stateflow</em>'.
     * @see com.engisis.sysphs.language.stateflow.SInstance#getOwningStateflow()
     * @see #getSInstance()
     * @generated
     */
	public EReference getSInstance_OwningStateflow() {
        return (EReference)sInstanceEClass.getEStructuralFeatures().get(2);
    }


				/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SConnectNode <em>SConnect Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SConnect Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.SConnectNode
     * @generated
     */
    public EClass getSConnectNode()
    {
        return sConnectNodeEClass;
    }


    /**
     * Returns the meta object for the reference list '{@link com.engisis.sysphs.language.stateflow.SConnectNode#getIncoming <em>Incoming</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Incoming</em>'.
     * @see com.engisis.sysphs.language.stateflow.SConnectNode#getIncoming()
     * @see #getSConnectNode()
     * @generated
     */
    public EReference getSConnectNode_Incoming()
    {
        return (EReference)sConnectNodeEClass.getEStructuralFeatures().get(0);
    }


    /**
     * Returns the meta object for the reference list '{@link com.engisis.sysphs.language.stateflow.SConnectNode#getOutgoing <em>Outgoing</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Outgoing</em>'.
     * @see com.engisis.sysphs.language.stateflow.SConnectNode#getOutgoing()
     * @see #getSConnectNode()
     * @generated
     */
    public EReference getSConnectNode_Outgoing()
    {
        return (EReference)sConnectNodeEClass.getEStructuralFeatures().get(1);
    }


    /**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SIdentifiedElement <em>SIdentified Element</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SIdentified Element</em>'.
     * @see com.engisis.sysphs.language.stateflow.SIdentifiedElement
     * @generated
     */
	public EClass getSIdentifiedElement() {
        return sIdentifiedElementEClass;
    }

	/**
     * Returns the meta object for the attribute '{@link com.engisis.sysphs.language.stateflow.SIdentifiedElement#getId <em>Id</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Id</em>'.
     * @see com.engisis.sysphs.language.stateflow.SIdentifiedElement#getId()
     * @see #getSIdentifiedElement()
     * @generated
     */
	public EAttribute getSIdentifiedElement_Id() {
        return (EAttribute)sIdentifiedElementEClass.getEStructuralFeatures().get(0);
    }

	/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SLinkNode <em>SLink Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>SLink Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.SLinkNode
     * @generated
     */
    public EClass getSLinkNode()
    {
        return sLinkNodeEClass;
    }


    /**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.SLinkNode#getOwningTreeNode <em>Owning Tree Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Tree Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.SLinkNode#getOwningTreeNode()
     * @see #getSLinkNode()
     * @generated
     */
    public EReference getSLinkNode_OwningTreeNode()
    {
        return (EReference)sLinkNodeEClass.getEStructuralFeatures().get(0);
    }


    /**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.STreeNode <em>STree Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>STree Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.STreeNode
     * @generated
     */
    public EClass getSTreeNode()
    {
        return sTreeNodeEClass;
    }


    /**
     * Returns the meta object for the containment reference list '{@link com.engisis.sysphs.language.stateflow.STreeNode#getTreeNode <em>Tree Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Tree Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.STreeNode#getTreeNode()
     * @see #getSTreeNode()
     * @generated
     */
    public EReference getSTreeNode_TreeNode()
    {
        return (EReference)sTreeNodeEClass.getEStructuralFeatures().get(0);
    }


    /**
     * Returns the meta object for the containment reference list '{@link com.engisis.sysphs.language.stateflow.STreeNode#getLinkNode <em>Link Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Link Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.STreeNode#getLinkNode()
     * @see #getSTreeNode()
     * @generated
     */
    public EReference getSTreeNode_LinkNode()
    {
        return (EReference)sTreeNodeEClass.getEStructuralFeatures().get(1);
    }


    /**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.STreeNode#getOwningTreeNode <em>Owning Tree Node</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Tree Node</em>'.
     * @see com.engisis.sysphs.language.stateflow.STreeNode#getOwningTreeNode()
     * @see #getSTreeNode()
     * @generated
     */
    public EReference getSTreeNode_OwningTreeNode()
    {
        return (EReference)sTreeNodeEClass.getEStructuralFeatures().get(2);
    }


    /**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SChartBlock <em>SChart Block</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SChart Block</em>'.
     * @see com.engisis.sysphs.language.stateflow.SChartBlock
     * @generated
     */
	public EClass getSChartBlock() {
        return sChartBlockEClass;
    }


				/**
     * Returns the meta object for the reference '{@link com.engisis.sysphs.language.stateflow.SChartBlock#getChart <em>Chart</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the reference '<em>Chart</em>'.
     * @see com.engisis.sysphs.language.stateflow.SChartBlock#getChart()
     * @see #getSChartBlock()
     * @generated
     */
	public EReference getSChartBlock_Chart() {
        return (EReference)sChartBlockEClass.getEStructuralFeatures().get(0);
    }


				/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.SChartSystem <em>SChart System</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>SChart System</em>'.
     * @see com.engisis.sysphs.language.stateflow.SChartSystem
     * @generated
     */
	public EClass getSChartSystem() {
        return sChartSystemEClass;
    }


				/**
     * Returns the meta object for class '{@link com.engisis.sysphs.language.stateflow.STarget <em>STarget</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for class '<em>STarget</em>'.
     * @see com.engisis.sysphs.language.stateflow.STarget
     * @generated
     */
	public EClass getSTarget() {
        return sTargetEClass;
    }


				/**
     * Returns the meta object for the container reference '{@link com.engisis.sysphs.language.stateflow.STarget#getOwningMachine <em>Owning Machine</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for the container reference '<em>Owning Machine</em>'.
     * @see com.engisis.sysphs.language.stateflow.STarget#getOwningMachine()
     * @see #getSTarget()
     * @generated
     */
	public EReference getSTarget_OwningMachine() {
        return (EReference)sTargetEClass.getEStructuralFeatures().get(0);
    }


				/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SStateType <em>SState Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SState Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SStateType
     * @generated
     */
	public EEnum getSStateType() {
        return sStateTypeEEnum;
    }

	/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SDecomposition <em>SDecomposition</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SDecomposition</em>'.
     * @see com.engisis.sysphs.language.stateflow.SDecomposition
     * @generated
     */
	public EEnum getSDecomposition() {
        return sDecompositionEEnum;
    }

	/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SJunctionType <em>SJunction Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SJunction Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SJunctionType
     * @generated
     */
	public EEnum getSJunctionType() {
        return sJunctionTypeEEnum;
    }

	/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SEventScope <em>SEvent Scope</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SEvent Scope</em>'.
     * @see com.engisis.sysphs.language.stateflow.SEventScope
     * @generated
     */
	public EEnum getSEventScope() {
        return sEventScopeEEnum;
    }

	/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SDataType <em>SData Type</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SData Type</em>'.
     * @see com.engisis.sysphs.language.stateflow.SDataType
     * @generated
     */
	public EEnum getSDataType() {
        return sDataTypeEEnum;
    }

	/**
     * Returns the meta object for enum '{@link com.engisis.sysphs.language.stateflow.SDataScope <em>SData Scope</em>}'.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the meta object for enum '<em>SData Scope</em>'.
     * @see com.engisis.sysphs.language.stateflow.SDataScope
     * @generated
     */
	public EEnum getSDataScope() {
        return sDataScopeEEnum;
    }

	/**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
	public StateflowFactory getStateflowFactory() {
        return (StateflowFactory)getEFactoryInstance();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private boolean isCreated = false;

	/**
     * Creates the meta-model objects for the package.  This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void createPackageContents() {
        if (isCreated) return;
        isCreated = true;

        // Create classes and their features
        sStateflowEClass = createEClass(SSTATEFLOW);
        createEReference(sStateflowEClass, SSTATEFLOW__MACHINE);
        createEReference(sStateflowEClass, SSTATEFLOW__INSTANCE);

        sMachineEClass = createEClass(SMACHINE);
        createEReference(sMachineEClass, SMACHINE__TARGET);
        createEReference(sMachineEClass, SMACHINE__CHART);
        createEReference(sMachineEClass, SMACHINE__OWNING_STATEFLOW);

        sChartEClass = createEClass(SCHART);
        createEReference(sChartEClass, SCHART__OWNING_MACHINE);

        sStateEClass = createEClass(SSTATE);
        createEAttribute(sStateEClass, SSTATE__LABEL);
        createEAttribute(sStateEClass, SSTATE__TYPE);
        createEAttribute(sStateEClass, SSTATE__DECOMPOSITION);

        sJunctionEClass = createEClass(SJUNCTION);
        createEAttribute(sJunctionEClass, SJUNCTION__TYPE);

        sTransitionEClass = createEClass(STRANSITION);
        createEReference(sTransitionEClass, STRANSITION__SRC);
        createEReference(sTransitionEClass, STRANSITION__DST);
        createEAttribute(sTransitionEClass, STRANSITION__LABEL);

        sDataEClass = createEClass(SDATA);
        createEAttribute(sDataEClass, SDATA__SCOPE);
        createEAttribute(sDataEClass, SDATA__DATA_TYPE);
        createEReference(sDataEClass, SDATA__MACHINE);
        createEReference(sDataEClass, SDATA__VALUE);

        sEventEClass = createEClass(SEVENT);
        createEAttribute(sEventEClass, SEVENT__SCOPE);
        createEReference(sEventEClass, SEVENT__MACHINE);

        sInstanceEClass = createEClass(SINSTANCE);
        createEReference(sInstanceEClass, SINSTANCE__MACHINE);
        createEReference(sInstanceEClass, SINSTANCE__CHART);
        createEReference(sInstanceEClass, SINSTANCE__OWNING_STATEFLOW);

        sConnectNodeEClass = createEClass(SCONNECT_NODE);
        createEReference(sConnectNodeEClass, SCONNECT_NODE__INCOMING);
        createEReference(sConnectNodeEClass, SCONNECT_NODE__OUTGOING);

        sIdentifiedElementEClass = createEClass(SIDENTIFIED_ELEMENT);
        createEAttribute(sIdentifiedElementEClass, SIDENTIFIED_ELEMENT__ID);

        sLinkNodeEClass = createEClass(SLINK_NODE);
        createEReference(sLinkNodeEClass, SLINK_NODE__OWNING_TREE_NODE);

        sTreeNodeEClass = createEClass(STREE_NODE);
        createEReference(sTreeNodeEClass, STREE_NODE__TREE_NODE);
        createEReference(sTreeNodeEClass, STREE_NODE__LINK_NODE);
        createEReference(sTreeNodeEClass, STREE_NODE__OWNING_TREE_NODE);

        sChartBlockEClass = createEClass(SCHART_BLOCK);
        createEReference(sChartBlockEClass, SCHART_BLOCK__CHART);

        sChartSystemEClass = createEClass(SCHART_SYSTEM);

        sTargetEClass = createEClass(STARGET);
        createEReference(sTargetEClass, STARGET__OWNING_MACHINE);

        // Create enums
        sStateTypeEEnum = createEEnum(SSTATE_TYPE);
        sDecompositionEEnum = createEEnum(SDECOMPOSITION);
        sJunctionTypeEEnum = createEEnum(SJUNCTION_TYPE);
        sEventScopeEEnum = createEEnum(SEVENT_SCOPE);
        sDataTypeEEnum = createEEnum(SDATA_TYPE);
        sDataScopeEEnum = createEEnum(SDATA_SCOPE);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private boolean isInitialized = false;

	/**
     * Complete the initialization of the package and its meta-model.  This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void initializePackageContents() {
        if (isInitialized) return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        SimulinkPackage theSimulinkPackage = (SimulinkPackage)EPackage.Registry.INSTANCE.getEPackage(SimulinkPackage.eNS_URI);

        // Create type parameters

        // Set bounds for type parameters

        // Add supertypes to classes
        sStateflowEClass.getESuperTypes().add(theSimulinkPackage.getSElement());
        sMachineEClass.getESuperTypes().add(this.getSIdentifiedElement());
        sChartEClass.getESuperTypes().add(this.getSTreeNode());
        sStateEClass.getESuperTypes().add(this.getSTreeNode());
        sStateEClass.getESuperTypes().add(this.getSConnectNode());
        sJunctionEClass.getESuperTypes().add(this.getSLinkNode());
        sJunctionEClass.getESuperTypes().add(this.getSConnectNode());
        sTransitionEClass.getESuperTypes().add(this.getSLinkNode());
        sDataEClass.getESuperTypes().add(this.getSLinkNode());
        sEventEClass.getESuperTypes().add(this.getSLinkNode());
        sInstanceEClass.getESuperTypes().add(this.getSIdentifiedElement());
        sIdentifiedElementEClass.getESuperTypes().add(theSimulinkPackage.getSNamedElement());
        sLinkNodeEClass.getESuperTypes().add(this.getSIdentifiedElement());
        sTreeNodeEClass.getESuperTypes().add(this.getSIdentifiedElement());
        sChartBlockEClass.getESuperTypes().add(theSimulinkPackage.getSSubsystem());
        sChartSystemEClass.getESuperTypes().add(theSimulinkPackage.getSSystem());
        sTargetEClass.getESuperTypes().add(this.getSIdentifiedElement());

        // Initialize classes and features; add operations and parameters
        initEClass(sStateflowEClass, SStateflow.class, "SStateflow", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSStateflow_Machine(), this.getSMachine(), this.getSMachine_OwningStateflow(), "machine", null, 1, 1, SStateflow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSStateflow_Instance(), this.getSInstance(), this.getSInstance_OwningStateflow(), "instance", null, 1, -1, SStateflow.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sMachineEClass, SMachine.class, "SMachine", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSMachine_Target(), this.getSTarget(), this.getSTarget_OwningMachine(), "target", null, 0, 1, SMachine.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSMachine_Chart(), this.getSChart(), this.getSChart_OwningMachine(), "chart", null, 0, -1, SMachine.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSMachine_OwningStateflow(), this.getSStateflow(), this.getSStateflow_Machine(), "owningStateflow", null, 0, 1, SMachine.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sChartEClass, SChart.class, "SChart", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSChart_OwningMachine(), this.getSMachine(), this.getSMachine_Chart(), "owningMachine", null, 1, 1, SChart.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sStateEClass, SState.class, "SState", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getSState_Label(), ecorePackage.getEString(), "label", null, 1, 1, SState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getSState_Type(), this.getSStateType(), "type", null, 0, 1, SState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getSState_Decomposition(), this.getSDecomposition(), "decomposition", null, 0, 1, SState.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sJunctionEClass, SJunction.class, "SJunction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getSJunction_Type(), this.getSJunctionType(), "type", null, 0, 1, SJunction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sTransitionEClass, STransition.class, "STransition", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSTransition_Src(), this.getSConnectNode(), this.getSConnectNode_Outgoing(), "src", null, 1, 1, STransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSTransition_Dst(), this.getSConnectNode(), this.getSConnectNode_Incoming(), "dst", null, 1, 1, STransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getSTransition_Label(), ecorePackage.getEString(), "label", null, 0, 1, STransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sDataEClass, SData.class, "SData", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getSData_Scope(), this.getSDataScope(), "scope", null, 0, 1, SData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEAttribute(getSData_DataType(), this.getSDataType(), "dataType", null, 0, 1, SData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSData_Machine(), this.getSMachine(), null, "machine", null, 1, 1, SData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSData_Value(), theSimulinkPackage.getSDataValue(), null, "value", null, 0, 1, SData.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sEventEClass, SEvent.class, "SEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getSEvent_Scope(), this.getSEventScope(), "scope", null, 0, 1, SEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSEvent_Machine(), this.getSMachine(), null, "machine", null, 1, 1, SEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sInstanceEClass, SInstance.class, "SInstance", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSInstance_Machine(), this.getSMachine(), null, "machine", null, 1, 1, SInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSInstance_Chart(), this.getSChart(), null, "chart", null, 1, 1, SInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSInstance_OwningStateflow(), this.getSStateflow(), this.getSStateflow_Instance(), "owningStateflow", null, 0, 1, SInstance.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sConnectNodeEClass, SConnectNode.class, "SConnectNode", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSConnectNode_Incoming(), this.getSTransition(), this.getSTransition_Dst(), "incoming", null, 0, -1, SConnectNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSConnectNode_Outgoing(), this.getSTransition(), this.getSTransition_Src(), "outgoing", null, 0, -1, SConnectNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sIdentifiedElementEClass, SIdentifiedElement.class, "SIdentifiedElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEAttribute(getSIdentifiedElement_Id(), ecorePackage.getEInt(), "id", null, 0, 1, SIdentifiedElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sLinkNodeEClass, SLinkNode.class, "SLinkNode", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSLinkNode_OwningTreeNode(), this.getSTreeNode(), this.getSTreeNode_LinkNode(), "owningTreeNode", null, 0, 1, SLinkNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sTreeNodeEClass, STreeNode.class, "STreeNode", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSTreeNode_TreeNode(), this.getSTreeNode(), this.getSTreeNode_OwningTreeNode(), "treeNode", null, 0, -1, STreeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSTreeNode_LinkNode(), this.getSLinkNode(), this.getSLinkNode_OwningTreeNode(), "linkNode", null, 0, -1, STreeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
        initEReference(getSTreeNode_OwningTreeNode(), this.getSTreeNode(), this.getSTreeNode_TreeNode(), "owningTreeNode", null, 0, 1, STreeNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sChartBlockEClass, SChartBlock.class, "SChartBlock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSChartBlock_Chart(), this.getSChart(), null, "chart", null, 1, 1, SChartBlock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        initEClass(sChartSystemEClass, SChartSystem.class, "SChartSystem", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

        initEClass(sTargetEClass, STarget.class, "STarget", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
        initEReference(getSTarget_OwningMachine(), this.getSMachine(), this.getSMachine_Target(), "owningMachine", null, 0, 1, STarget.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

        // Initialize enums and add enum literals
        initEEnum(sStateTypeEEnum, SStateType.class, "SStateType");
        addEEnumLiteral(sStateTypeEEnum, SStateType.OR);
        addEEnumLiteral(sStateTypeEEnum, SStateType.AND);

        initEEnum(sDecompositionEEnum, SDecomposition.class, "SDecomposition");
        addEEnumLiteral(sDecompositionEEnum, SDecomposition.CLUSTER);
        addEEnumLiteral(sDecompositionEEnum, SDecomposition.SET);

        initEEnum(sJunctionTypeEEnum, SJunctionType.class, "SJunctionType");
        addEEnumLiteral(sJunctionTypeEEnum, SJunctionType.CONNECTIVE);

        initEEnum(sEventScopeEEnum, SEventScope.class, "SEventScope");
        addEEnumLiteral(sEventScopeEEnum, SEventScope.LOCAL);
        addEEnumLiteral(sEventScopeEEnum, SEventScope.INPUT);
        addEEnumLiteral(sEventScopeEEnum, SEventScope.OUTPUT);

        initEEnum(sDataTypeEEnum, SDataType.class, "SDataType");
        addEEnumLiteral(sDataTypeEEnum, SDataType.INT32);

        initEEnum(sDataScopeEEnum, SDataScope.class, "SDataScope");
        addEEnumLiteral(sDataScopeEEnum, SDataScope.LOCAL);
        addEEnumLiteral(sDataScopeEEnum, SDataScope.INPUT);
        addEEnumLiteral(sDataScopeEEnum, SDataScope.OUTPUT);
        addEEnumLiteral(sDataScopeEEnum, SDataScope.CONSTANT);

        // Create resource
        createResource(eNS_URI);

        // Create annotations
        // http:///org/eclipse/emf/ecore/util/ExtendedMetaData
        createExtendedMetaDataAnnotations();
    }

	/**
     * Initializes the annotations for <b>http:///org/eclipse/emf/ecore/util/ExtendedMetaData</b>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected void createExtendedMetaDataAnnotations()
    {
        String source = "http:///org/eclipse/emf/ecore/util/ExtendedMetaData";	
        addAnnotation
          (getSConnectNode_Incoming(), 
           source, 
           new String[] 
           {
             "name", "incoming"
           });
    }

    /**
     * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
     * @generated
     */
	public interface Literals {
		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SStateflow <em>SStateflow</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SStateflow
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSStateflow()
         * @generated
         */
		public static final EClass SSTATEFLOW = eINSTANCE.getSStateflow();

		/**
         * The meta object literal for the '<em><b>Machine</b></em>' containment reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SSTATEFLOW__MACHINE = eINSTANCE.getSStateflow_Machine();

		/**
         * The meta object literal for the '<em><b>Instance</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SSTATEFLOW__INSTANCE = eINSTANCE.getSStateflow_Instance();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SMachine <em>SMachine</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SMachine
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSMachine()
         * @generated
         */
		public static final EClass SMACHINE = eINSTANCE.getSMachine();

		/**
         * The meta object literal for the '<em><b>Target</b></em>' containment reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SMACHINE__TARGET = eINSTANCE.getSMachine_Target();

		/**
         * The meta object literal for the '<em><b>Chart</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SMACHINE__CHART = eINSTANCE.getSMachine_Chart();

		/**
         * The meta object literal for the '<em><b>Owning Stateflow</b></em>' container reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SMACHINE__OWNING_STATEFLOW = eINSTANCE.getSMachine_OwningStateflow();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SChart <em>SChart</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SChart
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChart()
         * @generated
         */
		public static final EClass SCHART = eINSTANCE.getSChart();

		/**
         * The meta object literal for the '<em><b>Owning Machine</b></em>' container reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SCHART__OWNING_MACHINE = eINSTANCE.getSChart_OwningMachine();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SState <em>SState</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SState
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSState()
         * @generated
         */
		public static final EClass SSTATE = eINSTANCE.getSState();

		/**
         * The meta object literal for the '<em><b>Label</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EAttribute SSTATE__LABEL = eINSTANCE.getSState_Label();

        /**
         * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SSTATE__TYPE = eINSTANCE.getSState_Type();

		/**
         * The meta object literal for the '<em><b>Decomposition</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SSTATE__DECOMPOSITION = eINSTANCE.getSState_Decomposition();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SJunction <em>SJunction</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SJunction
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunction()
         * @generated
         */
		public static final EClass SJUNCTION = eINSTANCE.getSJunction();

		/**
         * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SJUNCTION__TYPE = eINSTANCE.getSJunction_Type();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.STransition <em>STransition</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.STransition
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTransition()
         * @generated
         */
		public static final EClass STRANSITION = eINSTANCE.getSTransition();

		/**
         * The meta object literal for the '<em><b>Src</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference STRANSITION__SRC = eINSTANCE.getSTransition_Src();

		/**
         * The meta object literal for the '<em><b>Dst</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference STRANSITION__DST = eINSTANCE.getSTransition_Dst();

		/**
         * The meta object literal for the '<em><b>Label</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EAttribute STRANSITION__LABEL = eINSTANCE.getSTransition_Label();

        /**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SData <em>SData</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SData
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSData()
         * @generated
         */
		public static final EClass SDATA = eINSTANCE.getSData();

		/**
         * The meta object literal for the '<em><b>Scope</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SDATA__SCOPE = eINSTANCE.getSData_Scope();

		/**
         * The meta object literal for the '<em><b>Data Type</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SDATA__DATA_TYPE = eINSTANCE.getSData_DataType();

		/**
         * The meta object literal for the '<em><b>Machine</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SDATA__MACHINE = eINSTANCE.getSData_Machine();

		/**
         * The meta object literal for the '<em><b>Value</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SDATA__VALUE = eINSTANCE.getSData_Value();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SEvent <em>SEvent</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SEvent
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSEvent()
         * @generated
         */
		public static final EClass SEVENT = eINSTANCE.getSEvent();

		/**
         * The meta object literal for the '<em><b>Scope</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SEVENT__SCOPE = eINSTANCE.getSEvent_Scope();

		/**
         * The meta object literal for the '<em><b>Machine</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SEVENT__MACHINE = eINSTANCE.getSEvent_Machine();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SInstance <em>SInstance</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SInstance
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSInstance()
         * @generated
         */
		public static final EClass SINSTANCE = eINSTANCE.getSInstance();

		/**
         * The meta object literal for the '<em><b>Machine</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SINSTANCE__MACHINE = eINSTANCE.getSInstance_Machine();

		/**
         * The meta object literal for the '<em><b>Chart</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SINSTANCE__CHART = eINSTANCE.getSInstance_Chart();

		/**
         * The meta object literal for the '<em><b>Owning Stateflow</b></em>' container reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SINSTANCE__OWNING_STATEFLOW = eINSTANCE.getSInstance_OwningStateflow();

								/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SConnectNode <em>SConnect Node</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SConnectNode
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSConnectNode()
         * @generated
         */
        public static final EClass SCONNECT_NODE = eINSTANCE.getSConnectNode();

        /**
         * The meta object literal for the '<em><b>Incoming</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference SCONNECT_NODE__INCOMING = eINSTANCE.getSConnectNode_Incoming();

        /**
         * The meta object literal for the '<em><b>Outgoing</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference SCONNECT_NODE__OUTGOING = eINSTANCE.getSConnectNode_Outgoing();

        /**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SIdentifiedElement <em>SIdentified Element</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SIdentifiedElement
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSIdentifiedElement()
         * @generated
         */
		public static final EClass SIDENTIFIED_ELEMENT = eINSTANCE.getSIdentifiedElement();

		/**
         * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EAttribute SIDENTIFIED_ELEMENT__ID = eINSTANCE.getSIdentifiedElement_Id();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SLinkNode <em>SLink Node</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SLinkNode
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSLinkNode()
         * @generated
         */
        public static final EClass SLINK_NODE = eINSTANCE.getSLinkNode();

        /**
         * The meta object literal for the '<em><b>Owning Tree Node</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference SLINK_NODE__OWNING_TREE_NODE = eINSTANCE.getSLinkNode_OwningTreeNode();

        /**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.STreeNode <em>STree Node</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.STreeNode
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTreeNode()
         * @generated
         */
        public static final EClass STREE_NODE = eINSTANCE.getSTreeNode();

        /**
         * The meta object literal for the '<em><b>Tree Node</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference STREE_NODE__TREE_NODE = eINSTANCE.getSTreeNode_TreeNode();

        /**
         * The meta object literal for the '<em><b>Link Node</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference STREE_NODE__LINK_NODE = eINSTANCE.getSTreeNode_LinkNode();

        /**
         * The meta object literal for the '<em><b>Owning Tree Node</b></em>' container reference feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        public static final EReference STREE_NODE__OWNING_TREE_NODE = eINSTANCE.getSTreeNode_OwningTreeNode();

        /**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SChartBlock <em>SChart Block</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SChartBlock
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChartBlock()
         * @generated
         */
		public static final EClass SCHART_BLOCK = eINSTANCE.getSChartBlock();

								/**
         * The meta object literal for the '<em><b>Chart</b></em>' reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference SCHART_BLOCK__CHART = eINSTANCE.getSChartBlock_Chart();

								/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SChartSystem <em>SChart System</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SChartSystem
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSChartSystem()
         * @generated
         */
		public static final EClass SCHART_SYSTEM = eINSTANCE.getSChartSystem();

								/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.STarget <em>STarget</em>}' class.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.STarget
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSTarget()
         * @generated
         */
		public static final EClass STARGET = eINSTANCE.getSTarget();

								/**
         * The meta object literal for the '<em><b>Owning Machine</b></em>' container reference feature.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @generated
         */
		public static final EReference STARGET__OWNING_MACHINE = eINSTANCE.getSTarget_OwningMachine();

								/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SStateType <em>SState Type</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SStateType
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSStateType()
         * @generated
         */
		public static final EEnum SSTATE_TYPE = eINSTANCE.getSStateType();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SDecomposition <em>SDecomposition</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SDecomposition
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDecomposition()
         * @generated
         */
		public static final EEnum SDECOMPOSITION = eINSTANCE.getSDecomposition();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SJunctionType <em>SJunction Type</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SJunctionType
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSJunctionType()
         * @generated
         */
		public static final EEnum SJUNCTION_TYPE = eINSTANCE.getSJunctionType();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SEventScope <em>SEvent Scope</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SEventScope
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSEventScope()
         * @generated
         */
		public static final EEnum SEVENT_SCOPE = eINSTANCE.getSEventScope();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SDataType <em>SData Type</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SDataType
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDataType()
         * @generated
         */
		public static final EEnum SDATA_TYPE = eINSTANCE.getSDataType();

		/**
         * The meta object literal for the '{@link com.engisis.sysphs.language.stateflow.SDataScope <em>SData Scope</em>}' enum.
         * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
         * @see com.engisis.sysphs.language.stateflow.SDataScope
         * @see com.engisis.sysphs.language.stateflow.StateflowPackage#getSDataScope()
         * @generated
         */
		public static final EEnum SDATA_SCOPE = eINSTANCE.getSDataScope();

	}

} //StateflowPackage
