/**
 */
package com.engisis.sysphs.language.stateflow.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import com.engisis.sysphs.language.simulink.SBlock;
import com.engisis.sysphs.language.simulink.SElement;
import com.engisis.sysphs.language.simulink.SNamedElement;
import com.engisis.sysphs.language.simulink.SSubsystem;
import com.engisis.sysphs.language.simulink.SSystem;
import com.engisis.sysphs.language.stateflow.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.engisis.sysphs.language.stateflow.StateflowPackage
 * @generated
 */
public class StateflowAdapterFactory extends AdapterFactoryImpl {
	/**
     * The cached model package.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected static StateflowPackage modelPackage;

	/**
     * Creates an instance of the adapter factory.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public StateflowAdapterFactory() {
        if (modelPackage == null)
        {
            modelPackage = StateflowPackage.eINSTANCE;
        }
    }

	/**
     * Returns whether this factory is applicable for the type of the object.
     * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
     * @return whether this factory is applicable for the type of the object.
     * @generated
     */
	@Override
	public boolean isFactoryForType(Object object) {
        if (object == modelPackage)
        {
            return true;
        }
        if (object instanceof EObject)
        {
            return ((EObject)object).eClass().getEPackage() == modelPackage;
        }
        return false;
    }

	/**
     * The switch that delegates to the <code>createXXX</code> methods.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected StateflowSwitch<Adapter> modelSwitch =
		new StateflowSwitch<Adapter>()
        {
            @Override
            public Adapter caseSStateflow(SStateflow object)
            {
                return createSStateflowAdapter();
            }
            @Override
            public Adapter caseSMachine(SMachine object)
            {
                return createSMachineAdapter();
            }
            @Override
            public Adapter caseSChart(SChart object)
            {
                return createSChartAdapter();
            }
            @Override
            public Adapter caseSState(SState object)
            {
                return createSStateAdapter();
            }
            @Override
            public Adapter caseSJunction(SJunction object)
            {
                return createSJunctionAdapter();
            }
            @Override
            public Adapter caseSTransition(STransition object)
            {
                return createSTransitionAdapter();
            }
            @Override
            public Adapter caseSData(SData object)
            {
                return createSDataAdapter();
            }
            @Override
            public Adapter caseSEvent(SEvent object)
            {
                return createSEventAdapter();
            }
            @Override
            public Adapter caseSInstance(SInstance object)
            {
                return createSInstanceAdapter();
            }
            @Override
            public Adapter caseSConnectNode(SConnectNode object)
            {
                return createSConnectNodeAdapter();
            }
            @Override
            public Adapter caseSIdentifiedElement(SIdentifiedElement object)
            {
                return createSIdentifiedElementAdapter();
            }
            @Override
            public Adapter caseSLinkNode(SLinkNode object)
            {
                return createSLinkNodeAdapter();
            }
            @Override
            public Adapter caseSTreeNode(STreeNode object)
            {
                return createSTreeNodeAdapter();
            }
            @Override
            public Adapter caseSChartBlock(SChartBlock object)
            {
                return createSChartBlockAdapter();
            }
            @Override
            public Adapter caseSChartSystem(SChartSystem object)
            {
                return createSChartSystemAdapter();
            }
            @Override
            public Adapter caseSTarget(STarget object)
            {
                return createSTargetAdapter();
            }
            @Override
            public Adapter caseSElement(SElement object)
            {
                return createSElementAdapter();
            }
            @Override
            public Adapter caseSNamedElement(SNamedElement object)
            {
                return createSNamedElementAdapter();
            }
            @Override
            public Adapter caseSBlock(SBlock object)
            {
                return createSBlockAdapter();
            }
            @Override
            public Adapter caseSSubsystem(SSubsystem object)
            {
                return createSSubsystemAdapter();
            }
            @Override
            public Adapter caseSSystem(SSystem object)
            {
                return createSSystemAdapter();
            }
            @Override
            public Adapter defaultCase(EObject object)
            {
                return createEObjectAdapter();
            }
        };

	/**
     * Creates an adapter for the <code>target</code>.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @param target the object to adapt.
     * @return the adapter for the <code>target</code>.
     * @generated
     */
	@Override
	public Adapter createAdapter(Notifier target) {
        return modelSwitch.doSwitch((EObject)target);
    }


	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SElement <em>SElement</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SElement
     * @generated
     */
	public Adapter createSElementAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SNamedElement <em>SNamed Element</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SNamedElement
     * @generated
     */
	public Adapter createSNamedElementAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SBlock <em>SBlock</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SBlock
     * @generated
     */
	public Adapter createSBlockAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSubsystem <em>SSubsystem</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSubsystem
     * @generated
     */
	public Adapter createSSubsystemAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.simulink.SSystem <em>SSystem</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.simulink.SSystem
     * @generated
     */
	public Adapter createSSystemAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SStateflow <em>SStateflow</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SStateflow
     * @generated
     */
	public Adapter createSStateflowAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SMachine <em>SMachine</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SMachine
     * @generated
     */
	public Adapter createSMachineAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SChart <em>SChart</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SChart
     * @generated
     */
	public Adapter createSChartAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SState <em>SState</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SState
     * @generated
     */
	public Adapter createSStateAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SJunction <em>SJunction</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SJunction
     * @generated
     */
	public Adapter createSJunctionAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.STransition <em>STransition</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.STransition
     * @generated
     */
	public Adapter createSTransitionAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SData <em>SData</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SData
     * @generated
     */
	public Adapter createSDataAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SEvent <em>SEvent</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SEvent
     * @generated
     */
	public Adapter createSEventAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SInstance <em>SInstance</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SInstance
     * @generated
     */
	public Adapter createSInstanceAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SConnectNode <em>SConnect Node</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SConnectNode
     * @generated
     */
    public Adapter createSConnectNodeAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SIdentifiedElement <em>SIdentified Element</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SIdentifiedElement
     * @generated
     */
	public Adapter createSIdentifiedElementAdapter() {
        return null;
    }

	/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SLinkNode <em>SLink Node</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SLinkNode
     * @generated
     */
    public Adapter createSLinkNodeAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.STreeNode <em>STree Node</em>}'.
     * <!-- begin-user-doc -->
     * This default implementation returns null so that we can easily ignore cases;
     * it's useful to ignore a case when inheritance will catch all the cases anyway.
     * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.STreeNode
     * @generated
     */
    public Adapter createSTreeNodeAdapter()
    {
        return null;
    }

    /**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SChartBlock <em>SChart Block</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SChartBlock
     * @generated
     */
	public Adapter createSChartBlockAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.SChartSystem <em>SChart System</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.SChartSystem
     * @generated
     */
	public Adapter createSChartSystemAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for an object of class '{@link com.engisis.sysphs.language.stateflow.STarget <em>STarget</em>}'.
     * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @see com.engisis.sysphs.language.stateflow.STarget
     * @generated
     */
	public Adapter createSTargetAdapter() {
        return null;
    }

				/**
     * Creates a new adapter for the default case.
     * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
     * @return the new adapter.
     * @generated
     */
	public Adapter createEObjectAdapter() {
        return null;
    }

} //StateflowAdapterFactory
