package com.engisis.sysphs.util;

import org.apache.log4j.Logger;

/***
 * Class for visitors through a dispatcher.
 * It should have "visit" methods with the type being visited as first argument.
 * @author barbau
 *
 */
public abstract class Visitor {
	static final Logger log = Logger.getLogger(Visitor.class);
	
	Dispatcher dispatcher;
	protected Dispatcher getDispatcher()
	{
		if (dispatcher == null)
			throw new IllegalStateException("This visitor must be added to a dispatcher");
		return dispatcher;
	}
}
